/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 74 "src/parse.yy"


#include "ispc.h"
#include "type.h"
#include "module.h"
#include "decl.h"
#include "expr.h"
#include "sym.h"
#include "stmt.h"
#include "util.h"

#include <stdio.h>
#include <llvm/IR/Constants.h>

#define UNIMPLEMENTED \
        Error(yylloc, "Unimplemented parser functionality %s:%d", \
        __FILE__, __LINE__);

union YYSTYPE;
extern int yylex();

extern char *yytext;

void yyerror(const char *s);

static int lYYTNameErr(char *yyres, const char *yystr);

static void lSuggestBuiltinAlternates();
static void lSuggestParamListAlternates();

static void lAddDeclaration(DeclSpecs *ds, Declarator *decl);
static void lAddFunctionParams(Declarator *decl);
static void lAddMaskToSymbolTable(SourcePos pos);
static void lAddThreadIndexCountToSymbolTable(SourcePos pos);
static std::string lGetAlternates(std::vector<std::string> &alternates);
static const char *lGetStorageClassString(StorageClass sc);
static bool lGetConstantInt(Expr *expr, int *value, SourcePos pos, const char *usage);
static EnumType *lCreateEnumType(const char *name, std::vector<Symbol *> *enums,
                                 SourcePos pos);
static void lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                                       const EnumType *enumType);

static const char *lBuiltinTokens[] = {
    "assert", "bool", "break", "case", "cdo",
    "cfor", "cif", "cwhile", "const", "continue", "default",
    "do", "delete", "double", "else", "enum", "export", "extern", "false",
    "float", "for", "foreach", "foreach_active", "foreach_tiled",
     "foreach_unique", "goto", "if", "in", "inline",
    "int", "int8", "int16", "int32", "int64", "launch", "new", "NULL",
    "print", "return", "signed", "sizeof", "static", "struct", "switch",
    "sync", "task", "true", "typedef", "uniform", "unmasked", "unsigned",
    "varying", "void", "while", NULL
};

static const char *lParamListTokens[] = {
    "bool", "const", "double", "enum", "false", "float", "int",
    "int8", "int16", "int32", "int64", "signed", "struct", "true",
    "uniform", "unsigned", "varying", "void", NULL
};

struct ForeachDimension {
    ForeachDimension(Symbol *s = NULL, Expr *b = NULL, Expr *e = NULL) {
        sym = s;
        beginExpr = b;
        endExpr = e;
    }
    Symbol *sym;
    Expr *beginExpr, *endExpr;
};


#line 143 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parse.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOKEN_INT8_CONSTANT = 3,        /* TOKEN_INT8_CONSTANT  */
  YYSYMBOL_TOKEN_UINT8_CONSTANT = 4,       /* TOKEN_UINT8_CONSTANT  */
  YYSYMBOL_TOKEN_INT16_CONSTANT = 5,       /* TOKEN_INT16_CONSTANT  */
  YYSYMBOL_TOKEN_UINT16_CONSTANT = 6,      /* TOKEN_UINT16_CONSTANT  */
  YYSYMBOL_TOKEN_INT32_CONSTANT = 7,       /* TOKEN_INT32_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32_CONSTANT = 8,      /* TOKEN_UINT32_CONSTANT  */
  YYSYMBOL_TOKEN_INT64_CONSTANT = 9,       /* TOKEN_INT64_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64_CONSTANT = 10,     /* TOKEN_UINT64_CONSTANT  */
  YYSYMBOL_TOKEN_INT32DOTDOTDOT_CONSTANT = 11, /* TOKEN_INT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32DOTDOTDOT_CONSTANT = 12, /* TOKEN_UINT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_INT64DOTDOTDOT_CONSTANT = 13, /* TOKEN_INT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64DOTDOTDOT_CONSTANT = 14, /* TOKEN_UINT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_FLOAT_CONSTANT = 15,      /* TOKEN_FLOAT_CONSTANT  */
  YYSYMBOL_TOKEN_DOUBLE_CONSTANT = 16,     /* TOKEN_DOUBLE_CONSTANT  */
  YYSYMBOL_TOKEN_STRING_C_LITERAL = 17,    /* TOKEN_STRING_C_LITERAL  */
  YYSYMBOL_TOKEN_IDENTIFIER = 18,          /* TOKEN_IDENTIFIER  */
  YYSYMBOL_TOKEN_STRING_LITERAL = 19,      /* TOKEN_STRING_LITERAL  */
  YYSYMBOL_TOKEN_TYPE_NAME = 20,           /* TOKEN_TYPE_NAME  */
  YYSYMBOL_TOKEN_NULL = 21,                /* TOKEN_NULL  */
  YYSYMBOL_TOKEN_PTR_OP = 22,              /* TOKEN_PTR_OP  */
  YYSYMBOL_TOKEN_INC_OP = 23,              /* TOKEN_INC_OP  */
  YYSYMBOL_TOKEN_DEC_OP = 24,              /* TOKEN_DEC_OP  */
  YYSYMBOL_TOKEN_LEFT_OP = 25,             /* TOKEN_LEFT_OP  */
  YYSYMBOL_TOKEN_RIGHT_OP = 26,            /* TOKEN_RIGHT_OP  */
  YYSYMBOL_TOKEN_LE_OP = 27,               /* TOKEN_LE_OP  */
  YYSYMBOL_TOKEN_GE_OP = 28,               /* TOKEN_GE_OP  */
  YYSYMBOL_TOKEN_EQ_OP = 29,               /* TOKEN_EQ_OP  */
  YYSYMBOL_TOKEN_NE_OP = 30,               /* TOKEN_NE_OP  */
  YYSYMBOL_TOKEN_AND_OP = 31,              /* TOKEN_AND_OP  */
  YYSYMBOL_TOKEN_OR_OP = 32,               /* TOKEN_OR_OP  */
  YYSYMBOL_TOKEN_MUL_ASSIGN = 33,          /* TOKEN_MUL_ASSIGN  */
  YYSYMBOL_TOKEN_DIV_ASSIGN = 34,          /* TOKEN_DIV_ASSIGN  */
  YYSYMBOL_TOKEN_MOD_ASSIGN = 35,          /* TOKEN_MOD_ASSIGN  */
  YYSYMBOL_TOKEN_ADD_ASSIGN = 36,          /* TOKEN_ADD_ASSIGN  */
  YYSYMBOL_TOKEN_SUB_ASSIGN = 37,          /* TOKEN_SUB_ASSIGN  */
  YYSYMBOL_TOKEN_LEFT_ASSIGN = 38,         /* TOKEN_LEFT_ASSIGN  */
  YYSYMBOL_TOKEN_RIGHT_ASSIGN = 39,        /* TOKEN_RIGHT_ASSIGN  */
  YYSYMBOL_TOKEN_AND_ASSIGN = 40,          /* TOKEN_AND_ASSIGN  */
  YYSYMBOL_TOKEN_OR_ASSIGN = 41,           /* TOKEN_OR_ASSIGN  */
  YYSYMBOL_TOKEN_XOR_ASSIGN = 42,          /* TOKEN_XOR_ASSIGN  */
  YYSYMBOL_TOKEN_SIZEOF = 43,              /* TOKEN_SIZEOF  */
  YYSYMBOL_TOKEN_NEW = 44,                 /* TOKEN_NEW  */
  YYSYMBOL_TOKEN_DELETE = 45,              /* TOKEN_DELETE  */
  YYSYMBOL_TOKEN_IN = 46,                  /* TOKEN_IN  */
  YYSYMBOL_TOKEN_EXTERN = 47,              /* TOKEN_EXTERN  */
  YYSYMBOL_TOKEN_EXPORT = 48,              /* TOKEN_EXPORT  */
  YYSYMBOL_TOKEN_STATIC = 49,              /* TOKEN_STATIC  */
  YYSYMBOL_TOKEN_INLINE = 50,              /* TOKEN_INLINE  */
  YYSYMBOL_TOKEN_NOINLINE = 51,            /* TOKEN_NOINLINE  */
  YYSYMBOL_TOKEN_VECTORCALL = 52,          /* TOKEN_VECTORCALL  */
  YYSYMBOL_TOKEN_TASK = 53,                /* TOKEN_TASK  */
  YYSYMBOL_TOKEN_DECLSPEC = 54,            /* TOKEN_DECLSPEC  */
  YYSYMBOL_TOKEN_UNIFORM = 55,             /* TOKEN_UNIFORM  */
  YYSYMBOL_TOKEN_VARYING = 56,             /* TOKEN_VARYING  */
  YYSYMBOL_TOKEN_TYPEDEF = 57,             /* TOKEN_TYPEDEF  */
  YYSYMBOL_TOKEN_SOA = 58,                 /* TOKEN_SOA  */
  YYSYMBOL_TOKEN_UNMASKED = 59,            /* TOKEN_UNMASKED  */
  YYSYMBOL_TOKEN_CHAR = 60,                /* TOKEN_CHAR  */
  YYSYMBOL_TOKEN_INT = 61,                 /* TOKEN_INT  */
  YYSYMBOL_TOKEN_SIGNED = 62,              /* TOKEN_SIGNED  */
  YYSYMBOL_TOKEN_UNSIGNED = 63,            /* TOKEN_UNSIGNED  */
  YYSYMBOL_TOKEN_FLOAT = 64,               /* TOKEN_FLOAT  */
  YYSYMBOL_TOKEN_DOUBLE = 65,              /* TOKEN_DOUBLE  */
  YYSYMBOL_TOKEN_INT8 = 66,                /* TOKEN_INT8  */
  YYSYMBOL_TOKEN_INT16 = 67,               /* TOKEN_INT16  */
  YYSYMBOL_TOKEN_INT64 = 68,               /* TOKEN_INT64  */
  YYSYMBOL_TOKEN_CONST = 69,               /* TOKEN_CONST  */
  YYSYMBOL_TOKEN_VOID = 70,                /* TOKEN_VOID  */
  YYSYMBOL_TOKEN_BOOL = 71,                /* TOKEN_BOOL  */
  YYSYMBOL_TOKEN_UINT8 = 72,               /* TOKEN_UINT8  */
  YYSYMBOL_TOKEN_UINT16 = 73,              /* TOKEN_UINT16  */
  YYSYMBOL_TOKEN_UINT = 74,                /* TOKEN_UINT  */
  YYSYMBOL_TOKEN_UINT64 = 75,              /* TOKEN_UINT64  */
  YYSYMBOL_TOKEN_ENUM = 76,                /* TOKEN_ENUM  */
  YYSYMBOL_TOKEN_STRUCT = 77,              /* TOKEN_STRUCT  */
  YYSYMBOL_TOKEN_TRUE = 78,                /* TOKEN_TRUE  */
  YYSYMBOL_TOKEN_FALSE = 79,               /* TOKEN_FALSE  */
  YYSYMBOL_TOKEN_CASE = 80,                /* TOKEN_CASE  */
  YYSYMBOL_TOKEN_DEFAULT = 81,             /* TOKEN_DEFAULT  */
  YYSYMBOL_TOKEN_IF = 82,                  /* TOKEN_IF  */
  YYSYMBOL_TOKEN_ELSE = 83,                /* TOKEN_ELSE  */
  YYSYMBOL_TOKEN_SWITCH = 84,              /* TOKEN_SWITCH  */
  YYSYMBOL_TOKEN_WHILE = 85,               /* TOKEN_WHILE  */
  YYSYMBOL_TOKEN_DO = 86,                  /* TOKEN_DO  */
  YYSYMBOL_TOKEN_LAUNCH = 87,              /* TOKEN_LAUNCH  */
  YYSYMBOL_TOKEN_FOREACH = 88,             /* TOKEN_FOREACH  */
  YYSYMBOL_TOKEN_FOREACH_TILED = 89,       /* TOKEN_FOREACH_TILED  */
  YYSYMBOL_TOKEN_FOREACH_UNIQUE = 90,      /* TOKEN_FOREACH_UNIQUE  */
  YYSYMBOL_TOKEN_FOREACH_ACTIVE = 91,      /* TOKEN_FOREACH_ACTIVE  */
  YYSYMBOL_TOKEN_DOTDOTDOT = 92,           /* TOKEN_DOTDOTDOT  */
  YYSYMBOL_TOKEN_FOR = 93,                 /* TOKEN_FOR  */
  YYSYMBOL_TOKEN_GOTO = 94,                /* TOKEN_GOTO  */
  YYSYMBOL_TOKEN_CONTINUE = 95,            /* TOKEN_CONTINUE  */
  YYSYMBOL_TOKEN_BREAK = 96,               /* TOKEN_BREAK  */
  YYSYMBOL_TOKEN_RETURN = 97,              /* TOKEN_RETURN  */
  YYSYMBOL_TOKEN_CIF = 98,                 /* TOKEN_CIF  */
  YYSYMBOL_TOKEN_CDO = 99,                 /* TOKEN_CDO  */
  YYSYMBOL_TOKEN_CFOR = 100,               /* TOKEN_CFOR  */
  YYSYMBOL_TOKEN_CWHILE = 101,             /* TOKEN_CWHILE  */
  YYSYMBOL_TOKEN_SYNC = 102,               /* TOKEN_SYNC  */
  YYSYMBOL_TOKEN_PRINT = 103,              /* TOKEN_PRINT  */
  YYSYMBOL_TOKEN_ASSERT = 104,             /* TOKEN_ASSERT  */
  YYSYMBOL_105_ = 105,                     /* '('  */
  YYSYMBOL_106_ = 106,                     /* ')'  */
  YYSYMBOL_107_ = 107,                     /* '['  */
  YYSYMBOL_108_ = 108,                     /* ']'  */
  YYSYMBOL_109_ = 109,                     /* ','  */
  YYSYMBOL_110_ = 110,                     /* '<'  */
  YYSYMBOL_111_ = 111,                     /* '>'  */
  YYSYMBOL_112_ = 112,                     /* '.'  */
  YYSYMBOL_113_ = 113,                     /* '&'  */
  YYSYMBOL_114_ = 114,                     /* '*'  */
  YYSYMBOL_115_ = 115,                     /* '+'  */
  YYSYMBOL_116_ = 116,                     /* '-'  */
  YYSYMBOL_117_ = 117,                     /* '~'  */
  YYSYMBOL_118_ = 118,                     /* '!'  */
  YYSYMBOL_119_ = 119,                     /* '/'  */
  YYSYMBOL_120_ = 120,                     /* '%'  */
  YYSYMBOL_121_ = 121,                     /* '^'  */
  YYSYMBOL_122_ = 122,                     /* '|'  */
  YYSYMBOL_123_ = 123,                     /* '?'  */
  YYSYMBOL_124_ = 124,                     /* ':'  */
  YYSYMBOL_125_ = 125,                     /* '='  */
  YYSYMBOL_126_ = 126,                     /* ';'  */
  YYSYMBOL_127_ = 127,                     /* '{'  */
  YYSYMBOL_128_ = 128,                     /* '}'  */
  YYSYMBOL_YYACCEPT = 129,                 /* $accept  */
  YYSYMBOL_string_constant = 130,          /* string_constant  */
  YYSYMBOL_primary_expression = 131,       /* primary_expression  */
  YYSYMBOL_launch_expression = 132,        /* launch_expression  */
  YYSYMBOL_postfix_expression = 133,       /* postfix_expression  */
  YYSYMBOL_funcall_expression = 134,       /* funcall_expression  */
  YYSYMBOL_argument_expression_list = 135, /* argument_expression_list  */
  YYSYMBOL_unary_expression = 136,         /* unary_expression  */
  YYSYMBOL_cast_expression = 137,          /* cast_expression  */
  YYSYMBOL_multiplicative_expression = 138, /* multiplicative_expression  */
  YYSYMBOL_additive_expression = 139,      /* additive_expression  */
  YYSYMBOL_shift_expression = 140,         /* shift_expression  */
  YYSYMBOL_relational_expression = 141,    /* relational_expression  */
  YYSYMBOL_equality_expression = 142,      /* equality_expression  */
  YYSYMBOL_and_expression = 143,           /* and_expression  */
  YYSYMBOL_exclusive_or_expression = 144,  /* exclusive_or_expression  */
  YYSYMBOL_inclusive_or_expression = 145,  /* inclusive_or_expression  */
  YYSYMBOL_logical_and_expression = 146,   /* logical_and_expression  */
  YYSYMBOL_logical_or_expression = 147,    /* logical_or_expression  */
  YYSYMBOL_conditional_expression = 148,   /* conditional_expression  */
  YYSYMBOL_rate_qualified_new = 149,       /* rate_qualified_new  */
  YYSYMBOL_rate_qualified_type_specifier = 150, /* rate_qualified_type_specifier  */
  YYSYMBOL_new_expression = 151,           /* new_expression  */
  YYSYMBOL_assignment_expression = 152,    /* assignment_expression  */
  YYSYMBOL_expression = 153,               /* expression  */
  YYSYMBOL_constant_expression = 154,      /* constant_expression  */
  YYSYMBOL_declaration_statement = 155,    /* declaration_statement  */
  YYSYMBOL_declaration = 156,              /* declaration  */
  YYSYMBOL_soa_width_specifier = 157,      /* soa_width_specifier  */
  YYSYMBOL_declspec_item = 158,            /* declspec_item  */
  YYSYMBOL_declspec_list = 159,            /* declspec_list  */
  YYSYMBOL_declspec_specifier = 160,       /* declspec_specifier  */
  YYSYMBOL_declaration_specifiers = 161,   /* declaration_specifiers  */
  YYSYMBOL_init_declarator_list = 162,     /* init_declarator_list  */
  YYSYMBOL_init_declarator = 163,          /* init_declarator  */
  YYSYMBOL_storage_class_specifier = 164,  /* storage_class_specifier  */
  YYSYMBOL_type_specifier = 165,           /* type_specifier  */
  YYSYMBOL_type_specifier_list = 166,      /* type_specifier_list  */
  YYSYMBOL_atomic_var_type_specifier = 167, /* atomic_var_type_specifier  */
  YYSYMBOL_short_vec_specifier = 168,      /* short_vec_specifier  */
  YYSYMBOL_struct_or_union_name = 169,     /* struct_or_union_name  */
  YYSYMBOL_struct_or_union_and_name = 170, /* struct_or_union_and_name  */
  YYSYMBOL_struct_or_union_specifier = 171, /* struct_or_union_specifier  */
  YYSYMBOL_struct_or_union = 172,          /* struct_or_union  */
  YYSYMBOL_struct_declaration_list = 173,  /* struct_declaration_list  */
  YYSYMBOL_struct_declaration = 174,       /* struct_declaration  */
  YYSYMBOL_specifier_qualifier_list = 175, /* specifier_qualifier_list  */
  YYSYMBOL_struct_declarator_list = 176,   /* struct_declarator_list  */
  YYSYMBOL_struct_declarator = 177,        /* struct_declarator  */
  YYSYMBOL_enum_identifier = 178,          /* enum_identifier  */
  YYSYMBOL_enum_specifier = 179,           /* enum_specifier  */
  YYSYMBOL_enumerator_list = 180,          /* enumerator_list  */
  YYSYMBOL_enumerator = 181,               /* enumerator  */
  YYSYMBOL_type_qualifier = 182,           /* type_qualifier  */
  YYSYMBOL_type_qualifier_list = 183,      /* type_qualifier_list  */
  YYSYMBOL_declarator = 184,               /* declarator  */
  YYSYMBOL_int_constant = 185,             /* int_constant  */
  YYSYMBOL_direct_declarator = 186,        /* direct_declarator  */
  YYSYMBOL_pointer = 187,                  /* pointer  */
  YYSYMBOL_reference = 188,                /* reference  */
  YYSYMBOL_parameter_type_list = 189,      /* parameter_type_list  */
  YYSYMBOL_parameter_list = 190,           /* parameter_list  */
  YYSYMBOL_parameter_declaration = 191,    /* parameter_declaration  */
  YYSYMBOL_type_name = 192,                /* type_name  */
  YYSYMBOL_abstract_declarator = 193,      /* abstract_declarator  */
  YYSYMBOL_direct_abstract_declarator = 194, /* direct_abstract_declarator  */
  YYSYMBOL_initializer = 195,              /* initializer  */
  YYSYMBOL_initializer_list = 196,         /* initializer_list  */
  YYSYMBOL_statement = 197,                /* statement  */
  YYSYMBOL_labeled_statement = 198,        /* labeled_statement  */
  YYSYMBOL_start_scope = 199,              /* start_scope  */
  YYSYMBOL_end_scope = 200,                /* end_scope  */
  YYSYMBOL_compound_statement = 201,       /* compound_statement  */
  YYSYMBOL_statement_list = 202,           /* statement_list  */
  YYSYMBOL_expression_statement = 203,     /* expression_statement  */
  YYSYMBOL_selection_statement = 204,      /* selection_statement  */
  YYSYMBOL_for_test = 205,                 /* for_test  */
  YYSYMBOL_for_init_statement = 206,       /* for_init_statement  */
  YYSYMBOL_for_scope = 207,                /* for_scope  */
  YYSYMBOL_cfor_scope = 208,               /* cfor_scope  */
  YYSYMBOL_foreach_scope = 209,            /* foreach_scope  */
  YYSYMBOL_foreach_tiled_scope = 210,      /* foreach_tiled_scope  */
  YYSYMBOL_foreach_identifier = 211,       /* foreach_identifier  */
  YYSYMBOL_foreach_active_scope = 212,     /* foreach_active_scope  */
  YYSYMBOL_foreach_active_identifier = 213, /* foreach_active_identifier  */
  YYSYMBOL_integer_dotdotdot = 214,        /* integer_dotdotdot  */
  YYSYMBOL_foreach_dimension_specifier = 215, /* foreach_dimension_specifier  */
  YYSYMBOL_foreach_dimension_list = 216,   /* foreach_dimension_list  */
  YYSYMBOL_foreach_unique_scope = 217,     /* foreach_unique_scope  */
  YYSYMBOL_foreach_unique_identifier = 218, /* foreach_unique_identifier  */
  YYSYMBOL_iteration_statement = 219,      /* iteration_statement  */
  YYSYMBOL_220_1 = 220,                    /* $@1  */
  YYSYMBOL_221_2 = 221,                    /* $@2  */
  YYSYMBOL_222_3 = 222,                    /* $@3  */
  YYSYMBOL_223_4 = 223,                    /* $@4  */
  YYSYMBOL_goto_identifier = 224,          /* goto_identifier  */
  YYSYMBOL_jump_statement = 225,           /* jump_statement  */
  YYSYMBOL_sync_statement = 226,           /* sync_statement  */
  YYSYMBOL_delete_statement = 227,         /* delete_statement  */
  YYSYMBOL_unmasked_statement = 228,       /* unmasked_statement  */
  YYSYMBOL_print_statement = 229,          /* print_statement  */
  YYSYMBOL_assert_statement = 230,         /* assert_statement  */
  YYSYMBOL_translation_unit = 231,         /* translation_unit  */
  YYSYMBOL_external_declaration = 232,     /* external_declaration  */
  YYSYMBOL_function_definition = 233,      /* function_definition  */
  YYSYMBOL_234_5 = 234                     /* $@5  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  81
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3324

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  106
/* YYNRULES -- Number of rules.  */
#define YYNRULES  343
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  647

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   359


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   118,     2,     2,     2,   120,   113,     2,
     105,   106,   114,   115,   109,   116,   112,   119,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   124,   126,
     110,   125,   111,   123,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   107,     2,   108,   121,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   127,   122,   128,   117,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   265,   265,   266,   275,   294,   298,   302,   306,   310,
     314,   318,   322,   326,   330,   334,   337,   340,   345,   346,
     350,   356,   363,   369,   376,   382,   388,   394,   401,   406,
     411,   416,   423,   429,   435,   441,   450,   451,   453,   455,
     456,   458,   460,   462,   467,   468,   470,   472,   477,   478,
     492,   493,   495,   497,   499,   501,   503,   505,   507,   509,
     511,   516,   517,   524,   525,   527,   529,   534,   535,   537,
     542,   543,   545,   550,   551,   553,   555,   557,   562,   563,
     565,   570,   571,   576,   577,   582,   583,   588,   589,   594,
     595,   600,   601,   606,   607,   608,   612,   613,   624,   635,
     659,   660,   664,   668,   675,   676,   678,   680,   682,   684,
     686,   688,   690,   692,   694,   696,   701,   702,   707,   711,
     737,   741,   748,   753,   763,   768,   777,   784,   788,   802,
     808,   818,   824,   835,   839,   845,   863,   867,   877,   884,
     898,   899,   908,   909,   910,   911,   915,   916,   921,   922,
     926,   937,   948,   949,   950,   951,   952,   953,   954,   955,
     956,   957,   958,   959,   963,   970,   971,   975,   997,   998,
    1017,  1031,  1039,  1056,  1060,  1067,  1081,  1086,  1087,  1088,
    1089,  1170,  1177,  1191,  1199,  1202,  1206,  1210,  1214,  1218,
    1241,  1251,  1265,  1269,  1285,  1286,  1287,  1288,  1289,  1290,
    1291,  1292,  1293,  1294,  1295,  1299,  1303,  1310,  1322,  1334,
    1338,  1339,  1340,  1341,  1345,  1351,  1355,  1373,  1384,  1388,
    1400,  1410,  1418,  1422,  1428,  1434,  1445,  1453,  1457,  1464,
    1473,  1481,  1485,  1494,  1501,  1518,  1519,  1531,  1535,  1536,
    1546,  1550,  1563,  1565,  1571,  1588,  1599,  1617,  1619,  1625,
    1635,  1649,  1650,  1651,  1655,  1657,  1671,  1672,  1673,  1674,
    1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1691,
    1695,  1705,  1710,  1714,  1718,  1719,  1723,  1729,  1742,  1743,
    1747,  1749,  1751,  1753,  1755,  1760,  1762,  1767,  1768,  1772,
    1776,  1780,  1784,  1788,  1795,  1799,  1806,  1810,  1814,  1818,
    1825,  1829,  1836,  1841,  1855,  1859,  1863,  1865,  1867,  1869,
    1871,  1875,  1879,  1883,  1888,  1887,  1916,  1915,  1945,  1944,
    1956,  1954,  1975,  1979,  1981,  1983,  1985,  1987,  1992,  1997,
    2004,  2011,  2015,  2022,  2029,  2030,  2031,  2035,  2036,  2037,
    2042,  2048,  2053,  2052
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOKEN_INT8_CONSTANT",
  "TOKEN_UINT8_CONSTANT", "TOKEN_INT16_CONSTANT", "TOKEN_UINT16_CONSTANT",
  "TOKEN_INT32_CONSTANT", "TOKEN_UINT32_CONSTANT", "TOKEN_INT64_CONSTANT",
  "TOKEN_UINT64_CONSTANT", "TOKEN_INT32DOTDOTDOT_CONSTANT",
  "TOKEN_UINT32DOTDOTDOT_CONSTANT", "TOKEN_INT64DOTDOTDOT_CONSTANT",
  "TOKEN_UINT64DOTDOTDOT_CONSTANT", "TOKEN_FLOAT_CONSTANT",
  "TOKEN_DOUBLE_CONSTANT", "TOKEN_STRING_C_LITERAL", "TOKEN_IDENTIFIER",
  "TOKEN_STRING_LITERAL", "TOKEN_TYPE_NAME", "TOKEN_NULL", "TOKEN_PTR_OP",
  "TOKEN_INC_OP", "TOKEN_DEC_OP", "TOKEN_LEFT_OP", "TOKEN_RIGHT_OP",
  "TOKEN_LE_OP", "TOKEN_GE_OP", "TOKEN_EQ_OP", "TOKEN_NE_OP",
  "TOKEN_AND_OP", "TOKEN_OR_OP", "TOKEN_MUL_ASSIGN", "TOKEN_DIV_ASSIGN",
  "TOKEN_MOD_ASSIGN", "TOKEN_ADD_ASSIGN", "TOKEN_SUB_ASSIGN",
  "TOKEN_LEFT_ASSIGN", "TOKEN_RIGHT_ASSIGN", "TOKEN_AND_ASSIGN",
  "TOKEN_OR_ASSIGN", "TOKEN_XOR_ASSIGN", "TOKEN_SIZEOF", "TOKEN_NEW",
  "TOKEN_DELETE", "TOKEN_IN", "TOKEN_EXTERN", "TOKEN_EXPORT",
  "TOKEN_STATIC", "TOKEN_INLINE", "TOKEN_NOINLINE", "TOKEN_VECTORCALL",
  "TOKEN_TASK", "TOKEN_DECLSPEC", "TOKEN_UNIFORM", "TOKEN_VARYING",
  "TOKEN_TYPEDEF", "TOKEN_SOA", "TOKEN_UNMASKED", "TOKEN_CHAR",
  "TOKEN_INT", "TOKEN_SIGNED", "TOKEN_UNSIGNED", "TOKEN_FLOAT",
  "TOKEN_DOUBLE", "TOKEN_INT8", "TOKEN_INT16", "TOKEN_INT64",
  "TOKEN_CONST", "TOKEN_VOID", "TOKEN_BOOL", "TOKEN_UINT8", "TOKEN_UINT16",
  "TOKEN_UINT", "TOKEN_UINT64", "TOKEN_ENUM", "TOKEN_STRUCT", "TOKEN_TRUE",
  "TOKEN_FALSE", "TOKEN_CASE", "TOKEN_DEFAULT", "TOKEN_IF", "TOKEN_ELSE",
  "TOKEN_SWITCH", "TOKEN_WHILE", "TOKEN_DO", "TOKEN_LAUNCH",
  "TOKEN_FOREACH", "TOKEN_FOREACH_TILED", "TOKEN_FOREACH_UNIQUE",
  "TOKEN_FOREACH_ACTIVE", "TOKEN_DOTDOTDOT", "TOKEN_FOR", "TOKEN_GOTO",
  "TOKEN_CONTINUE", "TOKEN_BREAK", "TOKEN_RETURN", "TOKEN_CIF",
  "TOKEN_CDO", "TOKEN_CFOR", "TOKEN_CWHILE", "TOKEN_SYNC", "TOKEN_PRINT",
  "TOKEN_ASSERT", "'('", "')'", "'['", "']'", "','", "'<'", "'>'", "'.'",
  "'&'", "'*'", "'+'", "'-'", "'~'", "'!'", "'/'", "'%'", "'^'", "'|'",
  "'?'", "':'", "'='", "';'", "'{'", "'}'", "$accept", "string_constant",
  "primary_expression", "launch_expression", "postfix_expression",
  "funcall_expression", "argument_expression_list", "unary_expression",
  "cast_expression", "multiplicative_expression", "additive_expression",
  "shift_expression", "relational_expression", "equality_expression",
  "and_expression", "exclusive_or_expression", "inclusive_or_expression",
  "logical_and_expression", "logical_or_expression",
  "conditional_expression", "rate_qualified_new",
  "rate_qualified_type_specifier", "new_expression",
  "assignment_expression", "expression", "constant_expression",
  "declaration_statement", "declaration", "soa_width_specifier",
  "declspec_item", "declspec_list", "declspec_specifier",
  "declaration_specifiers", "init_declarator_list", "init_declarator",
  "storage_class_specifier", "type_specifier", "type_specifier_list",
  "atomic_var_type_specifier", "short_vec_specifier",
  "struct_or_union_name", "struct_or_union_and_name",
  "struct_or_union_specifier", "struct_or_union",
  "struct_declaration_list", "struct_declaration",
  "specifier_qualifier_list", "struct_declarator_list",
  "struct_declarator", "enum_identifier", "enum_specifier",
  "enumerator_list", "enumerator", "type_qualifier", "type_qualifier_list",
  "declarator", "int_constant", "direct_declarator", "pointer",
  "reference", "parameter_type_list", "parameter_list",
  "parameter_declaration", "type_name", "abstract_declarator",
  "direct_abstract_declarator", "initializer", "initializer_list",
  "statement", "labeled_statement", "start_scope", "end_scope",
  "compound_statement", "statement_list", "expression_statement",
  "selection_statement", "for_test", "for_init_statement", "for_scope",
  "cfor_scope", "foreach_scope", "foreach_tiled_scope",
  "foreach_identifier", "foreach_active_scope",
  "foreach_active_identifier", "integer_dotdotdot",
  "foreach_dimension_specifier", "foreach_dimension_list",
  "foreach_unique_scope", "foreach_unique_identifier",
  "iteration_statement", "$@1", "$@2", "$@3", "$@4", "goto_identifier",
  "jump_statement", "sync_statement", "delete_statement",
  "unmasked_statement", "print_statement", "assert_statement",
  "translation_unit", "external_declaration", "function_definition", "$@5", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,    40,    41,    91,    93,    44,
      60,    62,    46,    38,    42,    43,    45,   126,    33,    47,
      37,    94,   124,    63,    58,    61,    59,   123,   125
};
#endif

#define YYPACT_NINF (-299)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-343)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     895,   -93,  -299,    79,   -15,  -299,  -299,  -299,  -299,  -299,
       3,  -299,  -299,  -299,    17,  -299,  -299,  -299,  -299,  -299,
    -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,
    -299,    -1,  -299,  -299,  -299,  3207,  3207,    64,  3207,  3143,
    -299,     6,  -299,    11,  -299,  3207,   855,  -299,  -299,  -299,
      12,   596,   169,   221,  -299,   183,   100,   234,  -299,  -299,
    -299,  -299,    32,  -299,  1419,  -299,   -67,  -299,   -70,   141,
      25,    25,  -299,   221,  -299,  2822,  -299,  -299,  2856,  -299,
    -299,  -299,  -299,  3207,  -299,   -77,  -299,  -299,    56,  -299,
    -299,  -299,  -299,   170,   166,   -75,  -299,   183,  -299,   193,
    -299,  1419,  -299,    32,  -299,  1035,   182,  3006,   994,   141,
     141,   210,  -299,  3247,   222,  -299,  2890,  -299,    32,  3247,
    -299,  2924,   213,    64,   596,   211,  -299,   169,  -299,  2521,
      -9,  -299,   -47,  -299,  -299,  -299,  -299,   228,  -299,  -299,
    -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,
    2553,  2553,  2606,  -299,   318,   323,  -299,  -299,  2488,  1336,
    2553,  2553,  2521,  2521,  2521,  2521,  1035,  -299,  -299,    54,
    -299,   342,  -299,   122,   209,   146,    70,   247,   260,   271,
     272,   375,    -7,  -299,  3106,  -299,  -299,  -299,   284,   763,
    -299,   125,  -299,    27,   330,   320,  -299,   368,  -299,  -299,
    -299,   377,  -299,  -299,   221,  -299,  -299,   -63,  -299,  -299,
    -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,    -4,
    -299,  1486,  -299,  -299,  1336,  -299,  -299,  -299,  2318,  1291,
      63,   383,   318,   323,  -299,   148,   145,   384,  -299,  -299,
    -299,  -299,  -299,  -299,  -299,   -40,   469,  -299,  -299,  1421,
    1551,   473,  2318,  2318,  2318,  2318,  2318,  2318,  2318,  2318,
    2318,  2318,  2318,  2521,  2521,  2521,  2521,  2521,  2521,  2521,
    2521,  2521,  2521,  2521,  2521,  2521,  2521,  2521,  2521,  2521,
    2521,  2318,   596,   596,   161,   596,  -299,  -299,   366,   370,
    2318,   372,  2521,   371,   392,   396,   398,   763,  -299,  -299,
    -299,  -299,  -299,   486,   380,   395,  1206,   404,   763,  -299,
     413,   400,   414,   419,  -299,   -51,  -299,  -299,  -299,  -299,
    -299,   507,  -299,  -299,   424,   428,   429,   430,   431,   433,
    -299,   415,  -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,
    2678,  2403,   416,    95,    95,  -299,   242,  -299,  3207,  -299,
    -299,   432,    32,  -299,  -299,   434,   277,   162,  1678,  -299,
    -299,  2318,  2755,   338,   338,  -299,  2521,   970,  -299,  -299,
     436,  -299,   154,  -299,   437,   344,  -299,  -299,  -299,  -299,
    -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,  -299,
    -299,   122,   122,   209,   209,   146,   146,   146,   146,    70,
      70,   247,   260,   271,   272,   375,   -14,  -299,  -299,  1035,
    2318,  -299,  -299,   -43,   763,   420,   763,  2318,  2318,  2318,
     461,  -299,   421,  -299,  -299,  -299,   -42,  2318,   463,  2318,
    -299,   530,   530,  -299,  -299,  -299,  -299,  1121,  1121,   535,
     535,   549,   572,   763,   490,  -299,   508,   509,  -299,   505,
    1035,   242,   242,  3083,  2435,  -299,  -299,  -299,  -299,  2576,
    2318,  1764,  -299,   155,  -299,  -299,  -299,  -299,  -299,  -299,
    2318,  -299,  -299,  2521,   186,   356,  -299,   635,   763,  -299,
     192,   220,   224,   512,  -299,  -299,   237,   513,   248,  -299,
       9,    16,  -299,  -299,  1248,  1248,  -299,   494,  -299,   257,
     262,  -299,   520,  -299,   581,  -299,  -299,  -299,  -299,  -299,
    -299,   522,  -299,   521,  2318,  1291,   173,   360,   519,   263,
    -299,  -299,  -299,  -299,  1035,  -299,  -299,  -299,   763,   763,
     763,  2318,   763,  2318,   763,  -299,   506,  2318,  2318,  -299,
     -19,  1806,  1892,  1636,  -299,   535,  -299,  -299,  2318,  -299,
    -299,   523,   295,  1934,  1291,  2318,  -299,   526,   563,  -299,
    -299,   287,   564,   302,  -299,  -299,   304,   312,  -299,   763,
     314,   763,   319,  -299,  -299,  -299,  -299,   556,  2318,   763,
    -299,   763,   763,   324,  2758,  2020,  -299,   331,   337,   541,
    -299,   763,   528,   763,   539,   548,   550,  -299,   763,  -299,
     763,  2318,  -299,  -299,  -299,  -299,  -299,  2318,   367,   566,
     345,  -299,  2062,  1291,  -299,  -299,  -299,  -299,  -299,  -299,
    -299,  -299,  -299,   763,   544,  2148,  -299,   570,  -299,   351,
     381,  -299,  1291,  -299,   352,  -299,  -299,  2190,   393,  -299,
    -299,   353,  2276,  -299,  -299,   357,  -299
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,   147,   143,   199,   145,   200,   201,   202,   197,
       0,   195,   196,   142,     0,   198,   158,   203,   204,   160,
     161,   154,   156,   162,   194,   152,   153,   155,   157,   159,
     163,     0,   173,   341,   340,   131,   129,     0,   127,   133,
     146,   168,   148,     0,   149,   136,     0,   334,   337,   336,
     144,     0,     0,     0,   184,     0,   189,   143,   199,   132,
     130,   214,     0,   226,   222,   120,     0,   138,   140,   209,
       0,     0,   128,     0,   135,     0,   165,   166,     0,   167,
     137,     1,   335,     0,   150,     0,   123,   124,     0,   210,
     211,   212,   213,     0,   192,     0,   190,     0,   144,     0,
     205,   223,   224,     0,   121,     0,     0,     0,     0,   207,
     208,     0,   172,   178,   146,   179,     0,   174,     0,     0,
     171,     0,     0,     0,     0,     0,   126,     0,   122,     0,
       0,   185,     0,   215,   206,   225,   139,   140,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,     4,    17,
       0,     0,     0,    93,     0,     0,    15,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,    39,    44,
      50,    61,    63,    67,    70,    73,    78,    81,    83,    85,
      87,    89,    91,   100,     0,   104,   251,   141,   272,     0,
     343,     0,   220,   234,     0,   227,   228,     0,   217,    61,
     118,     0,   134,   177,     0,   169,   175,     0,   181,   183,
     180,   170,   338,   151,   339,   125,   193,   187,   191,     0,
     186,     0,    51,    52,     0,    59,    94,    95,     0,     0,
       0,     0,   195,   196,   116,     0,   235,     0,    53,    54,
      55,    56,    57,    58,   254,     0,     0,    42,    43,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   101,     0,    96,   274,     0,     4,
       0,   198,     0,     0,     0,     0,     0,     0,   291,   292,
     304,   294,   289,     0,     0,     0,     0,     0,     0,   290,
       0,     0,     0,     0,   278,     0,   262,   119,   276,   256,
     257,     0,   258,   259,     0,     0,     0,     0,     0,     0,
     260,     0,   261,   265,   266,   267,   263,   264,   221,   230,
       0,     0,   231,   237,   240,   233,   238,   219,     0,   218,
     216,     0,     0,   176,   188,     0,     0,     0,     0,    19,
      18,     0,     0,   237,   240,   236,     0,     0,   252,    41,
       0,    45,     0,    48,     0,     0,    40,   106,   107,   108,
     109,   110,   111,   112,   113,   115,   114,   105,    64,    65,
      66,    68,    69,    71,    72,    76,    77,    74,    75,    79,
      80,    82,    84,    86,    88,    90,     0,    97,    98,     0,
       0,    99,   268,     0,     0,     0,     0,     0,     0,     0,
       0,   322,     0,   324,   325,   326,     0,     0,     0,     0,
     328,     0,     0,   279,   273,   277,   275,     0,     0,     0,
       0,     0,     0,     0,     0,   247,     0,     0,   243,     0,
       0,   239,   241,     0,     0,   229,   164,   182,    60,     0,
       0,     0,    21,     0,   117,    62,   253,   255,    47,    46,
       0,    38,    37,     0,     0,     0,   329,     0,     0,   271,
       0,     0,     0,     0,   323,   327,     0,     0,     0,     2,
       0,     0,   288,   287,     0,     0,   293,     0,   302,     0,
       0,   295,     0,   305,     0,   269,   248,   242,   244,   232,
     249,     0,   245,     0,     0,     0,     0,     0,     0,     0,
      20,    49,    92,   102,     0,   103,   330,   270,     0,     0,
       0,     0,     0,     0,     0,     3,     0,     0,     0,   285,
       0,     0,     0,     0,   314,     0,   316,   318,     0,   250,
     246,     0,     0,     0,     0,     0,    33,     0,   280,   284,
     306,     0,   282,     0,   307,   331,     0,     0,   286,     0,
       0,     0,     0,   296,   297,   298,   299,     0,     0,     0,
     303,     0,     0,     0,     0,     0,    23,     0,     0,     0,
      32,     0,     0,     0,     0,     0,     0,   310,     0,   312,
       0,     0,   301,   315,   317,   319,   320,     0,     0,     0,
       0,    22,     0,     0,   281,   308,   283,   309,   332,   333,
     311,   313,   300,     0,     0,     0,    35,     0,    25,     0,
       0,   321,     0,    27,     0,    34,    24,     0,     0,    26,
      29,     0,     0,    28,    31,     0,    30
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -299,   243,  -299,  -299,  -157,  -299,  -298,   -59,  -143,   180,
     202,     0,   203,   442,   418,   449,   462,   464,  -299,  -103,
    -299,  -299,  -299,  -105,  -107,  -119,    44,   142,   558,   616,
    -299,  -299,     2,  -299,   642,  -299,   116,  -299,   -48,  -299,
    -299,  -299,  -299,  -299,   668,    82,   -95,  -299,   402,   716,
    -299,   658,   -91,   215,  -299,   -29,   -69,   -55,   -57,  -180,
    -101,  -299,   408,   533,  -182,  -264,  -102,   349,  -285,  -299,
    -299,  -299,   653,   346,    46,  -299,   270,   336,  -299,  -299,
    -299,  -299,  -299,  -299,  -299,  -299,   230,   340,  -299,  -299,
    -299,  -299,  -299,  -299,  -299,   474,  -299,  -299,  -299,  -299,
    -299,  -299,  -299,   730,  -299,  -299
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   490,   167,   168,   169,   170,   372,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   284,   185,   234,   315,   201,   316,   317,    35,    87,
      88,    36,   123,    66,    67,    38,    39,    85,    40,   115,
      79,    41,    42,    43,   116,   117,   118,   207,   208,    94,
      44,    95,    96,    45,   101,    99,    93,    69,    70,    71,
     446,   195,   196,   237,   447,   346,   244,   245,   318,   319,
     189,   436,   320,   321,   322,   323,   541,   494,   324,   325,
     326,   327,   497,   328,   502,   578,   498,   499,   329,   504,
     330,   579,   581,   582,   623,   331,   332,   333,   334,   335,
     336,   337,    46,    47,    48,   106
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     186,   230,    37,   187,   111,   200,   194,   102,    68,    54,
     216,   345,   420,   344,    54,   109,   110,    54,   203,   240,
     241,   242,   243,   428,   210,   280,   200,   114,   535,    76,
     114,    77,   124,    49,   130,   535,   435,    59,    60,   218,
      72,    74,   103,    61,   135,    61,   352,    80,    37,   199,
      61,   125,   235,   131,   365,   105,   364,  -342,   361,   104,
     463,   186,   219,   353,   236,   114,   361,   361,   114,   367,
     199,   114,   357,   114,   137,   433,   246,   247,   248,   451,
     452,   220,    61,   476,   485,   246,   247,   248,   368,   209,
     361,   222,   223,   225,   137,   361,    50,   270,   271,   451,
     452,   238,   239,   199,   199,   199,   199,   568,    52,   193,
     473,   114,    51,    61,   235,   536,   281,   235,   537,   217,
     388,   389,   390,   356,   354,   538,    55,    53,   218,   236,
      62,   479,   340,    75,   341,   351,   343,    62,    78,    83,
      63,    64,    34,   375,   373,    63,    64,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   505,   249,
     344,   250,   126,   519,   342,   127,   251,    84,   358,    62,
     250,   268,   269,   415,   406,   251,   114,    63,    64,   363,
     272,   273,   364,   413,   246,   247,   248,    86,    34,   200,
      65,   113,   435,   527,   113,   246,   247,   248,   206,   426,
     340,    54,   341,   206,   199,   199,   199,   199,   199,   199,
     199,   199,   199,   199,   199,   199,   199,   199,   199,   199,
     199,   199,   449,   465,    89,   122,    90,    97,    91,   113,
      92,   338,   113,   199,   339,   113,   263,   113,   200,   566,
     213,   264,   265,   558,   559,   560,   107,   562,   108,   564,
     362,    98,   341,   373,   360,   587,   464,   361,    63,    64,
     469,   520,   186,   470,   470,   467,   409,   461,   410,   250,
     395,   396,   397,   398,   251,   113,   274,   275,   553,   100,
     250,   128,   199,   343,   597,   251,   599,   610,   109,   110,
     119,   129,   523,   119,   603,   524,   604,   605,   528,   133,
     286,   361,   516,   475,   186,   363,   614,   199,   616,   188,
     480,   481,   482,   620,   629,   621,   134,   246,   247,   248,
     486,   202,   488,   209,   266,   267,   529,   634,   119,   361,
     530,   119,   204,   361,   119,   513,   119,   214,   631,   641,
     113,   212,   193,   532,   645,   186,   361,   453,   509,   454,
     193,   200,   511,   105,   534,   517,   373,   361,   552,   246,
     247,   248,   226,   544,   193,   521,   545,   227,   546,   557,
     522,   545,   470,   276,   119,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   459,   460,   540,   540,   246,
     247,   248,   277,   592,   278,   199,   361,   588,   407,   408,
     585,   411,   250,   246,   247,   248,   279,   251,   594,   551,
     595,   361,   287,   470,   199,   246,   247,   248,   596,   186,
     598,   361,   467,   361,   561,   600,   563,   608,   361,   348,
     606,   567,   373,   361,   570,   572,   347,   611,   577,   119,
     470,   583,   612,   362,   250,   341,   391,   392,   373,   251,
     589,   627,   472,   361,   470,   193,   630,   636,   639,   643,
     470,   470,   470,   646,   525,   361,   470,   262,   554,   555,
     393,   394,   625,   602,   250,   638,   349,   399,   400,   251,
     373,   492,   492,   493,   493,   350,   637,   369,   250,   359,
     366,   376,   412,   251,  -322,   416,   622,   417,   642,   414,
     250,   418,   624,   419,   421,   251,   423,   373,   288,   427,
     138,   139,   140,   141,   142,   143,   144,   145,   429,   431,
     373,   424,   146,   147,   432,   289,   430,     2,   149,   437,
     150,   151,   373,   438,   439,   440,   441,   373,   442,   443,
     458,   450,   468,   456,   478,   471,   483,   484,   487,   489,
     152,   153,   290,   496,    57,    58,     5,     6,     7,     8,
       9,    10,   232,   233,    13,    14,   291,   501,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,   156,   157,   292,   293,   294,
     503,   295,   296,   297,   158,   298,   299,   300,   301,   339,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   159,   508,   506,   507,     2,   531,   533,   543,
     160,   161,   162,   163,   164,   165,   547,   548,   549,   550,
     556,   584,   565,   314,   188,   434,   288,   590,   138,   139,
     140,   141,   142,   143,   144,   145,   591,   593,   601,   613,
     146,   147,   632,   289,   615,     2,   149,    16,   150,   151,
      19,    20,    21,    22,    23,   617,    25,    26,    27,    28,
      29,    30,    31,    32,   618,   491,   619,   626,   152,   153,
     290,   635,    57,    58,     5,     6,     7,     8,     9,    10,
     232,   233,    13,    14,   291,   402,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,   156,   157,   292,   293,   294,   401,   295,
     296,   297,   158,   298,   299,   300,   301,   403,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     159,   404,   285,   215,   405,   136,   121,    56,   160,   161,
     162,   163,   164,   165,   457,   132,   455,   355,   474,   190,
     477,   314,   188,   526,   288,   542,   138,   139,   140,   141,
     142,   143,   144,   145,   495,   580,    82,   422,   146,   147,
     500,   289,     0,     2,   149,     0,   150,   151,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   152,   153,   290,     0,
      57,    58,     5,     6,     7,     8,     9,    10,   232,   233,
      13,    14,   291,     0,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,   156,   157,   292,   293,   294,     0,   295,   296,   297,
     158,   298,   299,   300,   301,    81,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   159,     0,
       0,     0,     0,     0,     0,     2,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,     0,   314,
     188,     0,     0,     0,     0,     0,     1,     0,     0,     0,
       0,     0,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,     2,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,     0,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,   138,   139,   140,   141,   142,   143,   144,
     145,    33,     0,     0,     0,   146,   147,     0,   148,     0,
       0,   149,     0,   150,   151,   197,     0,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,   146,
     147,     0,   148,   152,   153,   149,     0,   150,   151,     0,
       0,    33,     0,     0,     0,   154,   155,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   152,   138,   139,
     140,   141,   142,   143,   144,   145,     0,     0,   156,   157,
     146,   147,     0,   148,     0,     0,   149,   158,   150,   151,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   156,   157,     0,   159,     0,     0,   152,   153,
       0,   158,     0,   160,   161,   162,   163,   164,   165,     0,
     154,   155,     0,     0,     0,     0,     0,   166,   466,   159,
       0,     0,   198,     0,     0,     0,     0,   160,   161,   162,
     163,   164,   165,   156,   157,     0,     0,     0,     0,     0,
       0,     0,   158,     0,   138,   139,   140,   141,   142,   143,
     144,   145,     0,     0,     0,     0,   146,   147,     0,   148,
     159,     2,   149,     0,   150,   151,     0,     0,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     0,     0,     0,
       0,     0,   166,     0,   152,   153,     0,     0,    57,    58,
       5,     6,     7,     8,     9,    10,   232,   233,    13,    14,
      15,     0,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,   156,
     157,     0,     0,     0,     0,     0,     0,     0,   158,   138,
     139,   140,   141,   142,   143,   144,   145,     0,     0,     0,
       0,   146,   147,     0,   148,     0,   159,   149,     0,   150,
     151,     0,     0,     0,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,     0,   314,     0,   152,
     153,   138,   139,   140,   141,   142,   143,   144,   145,     0,
       0,   154,   155,   146,   147,     0,   148,     0,     0,   149,
       0,   150,   151,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   156,   157,     0,     0,     0,     0,
       0,   152,   153,   158,   138,   139,   140,   141,   142,   143,
     144,   145,     0,   154,   155,     0,   146,   147,     0,   148,
       0,   159,   149,     0,     0,     0,     0,     0,     0,   160,
     161,   162,   163,   164,   165,     0,   156,   157,     0,     0,
       0,     0,   425,     0,     0,   158,     0,   231,     0,   138,
     139,   140,   141,   142,   143,   144,   145,     0,     0,     0,
       0,   146,   147,   159,   148,     0,     2,   149,     0,   150,
     151,   160,   161,   162,   163,   164,   165,     0,     0,   156,
     157,     0,     0,     0,   539,     0,     0,     0,   158,   152,
     153,     0,     0,     0,    58,     0,     6,     7,     8,     9,
       0,   232,   233,     0,     0,    15,   221,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,   156,   157,     0,     0,     0,     0,
       0,     0,   370,   158,   138,   139,   140,   141,   142,   143,
     144,   145,     0,     0,     0,     0,   146,   147,     0,   148,
       0,   159,   149,     0,   150,   151,     0,     0,     0,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   152,   153,     0,    58,     0,     6,
       7,     8,     9,     0,    11,    12,   154,   155,    15,     0,
       0,    17,    18,     0,     0,     0,     0,   231,    24,   138,
     139,   140,   141,   142,   143,   144,   145,     0,     0,   156,
     157,   146,   147,     0,   148,     0,     0,   149,   158,   150,
     151,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   159,   371,     0,   152,
     153,     0,     0,    64,   160,   161,   162,   163,   164,   165,
       0,   154,   155,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   374,     0,   138,   139,   140,   141,   142,   143,
     144,   145,     0,     0,   156,   157,   146,   147,     0,   148,
       0,     0,   149,   158,   150,   151,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   159,     0,     0,   152,   153,     0,     0,     0,   160,
     161,   162,   163,   164,   165,     0,   154,   155,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   156,
     157,     0,     0,     0,     0,     0,     0,     0,   158,   138,
     139,   140,   141,   142,   143,   144,   145,   573,   574,   575,
     576,   146,   147,     0,   148,     0,   159,   149,     0,   150,
     151,     0,     0,     0,   160,   161,   162,   163,   164,   165,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   152,
     153,   138,   139,   140,   141,   142,   143,   144,   145,     0,
       0,   154,   155,   146,   147,     0,   148,     0,     0,   149,
       0,   150,   151,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   156,   157,     0,     0,     0,     0,
       0,   152,   153,   158,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   154,   155,     0,     0,     0,     0,     0,
       0,   159,     0,     0,     0,     0,     0,     0,     0,   160,
     161,   162,   163,   164,   165,     0,   156,   157,     0,     0,
       0,     0,     0,     0,     0,   158,     0,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,     0,     0,   146,
     147,     0,   148,   159,   462,   149,     0,   150,   151,     0,
       0,   160,   161,   162,   163,   164,   165,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   152,   153,   138,
     139,   140,   141,   142,   143,   144,   145,     0,     0,   154,
     155,   146,   147,     0,   148,     0,     0,   149,     0,   150,
     151,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   156,   157,     0,     0,     0,     0,     0,   152,
     153,   158,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   154,   155,     0,     0,     0,     0,     0,     0,   159,
     518,     0,     0,     0,     0,     0,     0,   160,   161,   162,
     163,   164,   165,     0,   156,   157,     0,     0,     0,     0,
       0,     0,     0,   158,     0,   138,   139,   140,   141,   142,
     143,   144,   145,     0,     0,     0,     0,   146,   147,     0,
     148,   159,   569,   149,     0,   150,   151,     0,     0,   160,
     161,   162,   163,   164,   165,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   152,   153,   138,   139,   140,
     141,   142,   143,   144,   145,     0,     0,   154,   155,   146,
     147,     0,   148,     0,     0,   149,     0,   150,   151,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     156,   157,     0,     0,     0,     0,     0,   152,   153,   158,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   154,
     155,     0,     0,     0,     0,     0,     0,   159,   571,     0,
       0,     0,     0,     0,     0,   160,   161,   162,   163,   164,
     165,     0,   156,   157,     0,     0,     0,     0,     0,     0,
       0,   158,     0,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,   146,   147,     0,   148,   159,
     586,   149,     0,   150,   151,     0,     0,   160,   161,   162,
     163,   164,   165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   152,   153,   138,   139,   140,   141,   142,
     143,   144,   145,     0,     0,   154,   155,   146,   147,     0,
     148,     0,     0,   149,     0,   150,   151,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   156,   157,
       0,     0,     0,     0,     0,   152,   153,   158,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   154,   155,     0,
       0,     0,     0,     0,     0,   159,   609,     0,     0,     0,
       0,     0,     0,   160,   161,   162,   163,   164,   165,     0,
     156,   157,     0,     0,     0,     0,     0,     0,     0,   158,
       0,   138,   139,   140,   141,   142,   143,   144,   145,     0,
       0,     0,     0,   146,   147,     0,   148,   159,   628,   149,
       0,   150,   151,     0,     0,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   152,   153,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,   154,   155,   146,   147,     0,   148,     0,
       0,   149,     0,   150,   151,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   156,   157,     0,     0,
       0,     0,     0,   152,   153,   158,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   154,   155,     0,     0,     0,
       0,     0,     0,   159,   633,     0,     0,     0,     0,     0,
       0,   160,   161,   162,   163,   164,   165,     0,   156,   157,
       0,     0,     0,     0,     0,     0,     0,   158,     0,   138,
     139,   140,   141,   142,   143,   144,   145,     0,     0,     0,
       0,   146,   147,     0,   148,   159,   640,   149,     0,   150,
     151,     0,     0,   160,   161,   162,   163,   164,   165,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   152,
     153,   138,   139,   140,   141,   142,   143,   144,   145,     0,
       0,   154,   155,   146,   147,     0,   148,     0,     0,   149,
       0,   150,   151,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   156,   157,     0,     0,     0,     0,
       0,   152,   153,   158,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   154,   155,     0,     0,     0,     0,     0,
       0,   159,   644,     0,     0,     0,     0,     0,     0,   160,
     161,   162,   163,   164,   165,     0,   156,   157,     0,     0,
       0,     0,     0,     0,     0,   158,   138,   139,   140,   141,
     142,   143,   144,   145,     0,     0,     0,     0,   146,   147,
       0,   148,     0,   159,   149,     0,   150,   151,     0,     0,
       0,   160,   161,   162,   163,   164,   165,     0,   138,   139,
     140,   141,   142,   143,   144,   145,   152,     0,     0,     0,
     146,   147,     0,   148,     0,     0,   149,     0,   150,   151,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   152,     0,
       0,   156,   157,     0,     0,     0,     0,     0,     0,     0,
     158,   138,   139,   140,   141,   142,   143,   144,   145,     0,
       0,     0,     0,   146,   147,     0,   148,     0,   159,   149,
       0,   448,     0,   156,   157,     0,   160,   161,   162,   163,
     164,   165,   158,     0,   138,   139,   140,   141,   142,   143,
     144,   145,     0,     0,     0,     0,   146,   147,     0,   148,
     159,     0,   149,   512,   150,   151,     0,     0,   160,   161,
     162,   163,   164,   165,     0,     0,   138,   139,   140,   141,
     142,   143,   144,   145,   152,     0,   156,   157,   146,   147,
       0,   148,     0,     0,   149,   158,   150,   151,     0,   138,
     139,   140,   141,   142,   143,   144,   145,     0,     0,     0,
       0,   146,   147,   221,   148,   228,   152,   149,   229,   156,
     157,     0,     0,     0,     0,     0,     0,     0,   158,   138,
     139,   140,   141,   142,   143,   144,   145,     0,     0,     0,
       0,   146,   147,     0,   148,     0,   159,   149,     0,   150,
     151,   156,   157,     0,   160,   161,   162,   163,   164,   165,
     158,     0,     0,     0,     0,     0,     0,     0,     0,   152,
       0,     0,     0,     0,   156,   157,     0,     0,   221,     0,
       0,     0,     0,   158,     0,     0,   160,   161,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,     0,   444,
       0,   221,     0,   514,   156,   157,   515,     0,     0,     0,
       0,     0,     0,   158,     0,     0,    61,     0,     2,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,     0,     0,     0,     0,     0,     0,     0,   160,
     161,   162,   163,   164,   165,    57,    58,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,     0,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,   444,     0,     0,     0,
       0,   138,   139,   140,   141,   142,   143,   144,   145,     0,
       0,     0,     0,   146,   147,     2,   148,     0,     0,   149,
       0,     0,     0,   340,   445,   341,     0,     0,     0,     0,
       0,    63,    64,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    57,    58,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,     0,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,     0,     0,     0,   156,   157,     0,     0,
       0,     0,     2,     0,     0,   158,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     362,   445,   341,   221,     0,   607,     0,     0,    63,    64,
      58,     0,     6,     7,     8,     9,     2,    11,    12,     0,
       0,    15,     0,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
       0,     0,     0,     0,    58,     0,     6,     7,     8,     9,
       2,    11,    12,     0,     0,    15,     0,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,     0,     0,     0,     0,    58,     0,
       6,     7,     8,     9,     2,    11,    12,     0,     0,    15,
     112,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,     0,     0,
       0,     0,    58,     0,     6,     7,     8,     9,     0,    11,
      12,     0,     0,    15,   120,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,     0,     0,     0,     0,     0,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   205,     0,
       0,     0,     0,     0,     0,     0,     2,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,    57,    58,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,     0,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,   444,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     0,     0,     0,     0,     0,     0,
       0,     0,   192,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     2,     0,     0,     0,
      57,    58,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,     0,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,   282,   283,     2,    14,     0,     0,    16,     0,     0,
      19,    20,    21,    22,    23,     0,    25,    26,    27,    28,
      29,    30,    31,    32,     0,     0,     0,     0,     0,   510,
      57,    58,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,     0,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,     0,     0,     0,     0,     0,     0,     2,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    73,    57,    58,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,     2,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    58,     0,     6,     7,     8,
       9,     0,    11,    12,     0,     0,    15,     0,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32
};

static const yytype_int16 yycheck[] =
{
     105,   158,     0,   105,    73,   108,   107,    64,    37,    18,
     129,   193,   297,   193,    18,    70,    71,    18,   113,   162,
     163,   164,   165,   308,   119,    32,   129,    75,    19,    18,
      78,    20,   109,   126,   109,    19,   321,    35,    36,   130,
      38,    39,   109,    18,   101,    18,   109,    45,    46,   108,
      18,   128,   159,   128,   236,   125,   236,   127,   109,   126,
     358,   166,   109,   126,   159,   113,   109,   109,   116,   109,
     129,   119,   229,   121,   103,   126,    22,    23,    24,   343,
     344,   128,    18,   126,   126,    22,    23,    24,   128,   118,
     109,   150,   151,   152,   123,   109,    17,    27,    28,   363,
     364,   160,   161,   162,   163,   164,   165,   126,   105,   107,
     124,   159,   127,    18,   221,   106,   123,   224,   109,   128,
     263,   264,   265,   228,   128,   109,   127,   110,   219,   224,
     105,   416,   105,   127,   107,   204,   193,   105,   127,   127,
     113,   114,     0,   250,   249,   113,   114,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   443,   105,
     340,   107,   106,   461,   193,   109,   112,    51,   105,   105,
     107,    25,    26,   292,   281,   112,   224,   113,   114,   236,
     110,   111,   362,   290,    22,    23,    24,    18,    46,   292,
     126,    75,   477,   478,    78,    22,    23,    24,   116,   306,
     105,    18,   107,   121,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   341,   366,     3,    83,     5,   127,     7,   113,
       9,   106,   116,   292,   109,   119,   114,   121,   341,   537,
     124,   119,   120,   528,   529,   530,   105,   532,   107,   534,
     105,    17,   107,   358,   106,   553,   361,   109,   113,   114,
     106,   106,   367,   109,   109,   367,   105,   105,   107,   107,
     270,   271,   272,   273,   112,   159,    29,    30,   105,    64,
     107,   111,   341,   340,   569,   112,   571,   585,   343,   344,
      75,   125,   106,    78,   579,   109,   581,   582,   106,   106,
     184,   109,   459,   410,   409,   362,   591,   366,   593,   127,
     417,   418,   419,   598,   612,   600,   101,    22,    23,    24,
     427,   111,   429,   352,   115,   116,   106,   625,   113,   109,
     106,   116,   110,   109,   119,   454,   121,   126,   623,   637,
     224,   128,   340,   106,   642,   450,   109,   105,   450,   107,
     348,   454,   453,   125,   106,   460,   461,   109,   515,    22,
      23,    24,    44,   106,   362,   470,   109,    44,   106,   106,
     473,   109,   109,   113,   159,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,   108,   109,   494,   495,    22,
      23,    24,   121,   106,   122,   454,   109,   554,   282,   283,
     105,   285,   107,    22,    23,    24,    31,   112,   106,   514,
     106,   109,   128,   109,   473,    22,    23,    24,   106,   524,
     106,   109,   524,   109,   531,   106,   533,   584,   109,   109,
     106,   538,   537,   109,   541,   542,   106,   106,   543,   224,
     109,   548,   105,   105,   107,   107,   266,   267,   553,   112,
     555,   106,   108,   109,   109,   453,   613,   106,   106,   106,
     109,   109,   109,   106,   108,   109,   109,   125,   108,   109,
     268,   269,   105,   578,   107,   632,   108,   274,   275,   112,
     585,   437,   438,   437,   438,   108,   105,    18,   107,   106,
     106,    18,   126,   112,   124,   124,   601,   105,   105,   127,
     107,   105,   607,   105,    18,   112,   126,   612,     1,   105,
       3,     4,     5,     6,     7,     8,     9,    10,   105,   105,
     625,   126,    15,    16,   105,    18,   126,    20,    21,   105,
      23,    24,   637,   105,   105,   105,   105,   642,   105,   124,
     106,   125,   106,   111,   124,   108,    85,   126,    85,    19,
      43,    44,    45,    18,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    18,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      18,    84,    85,    86,    87,    88,    89,    90,    91,   109,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   108,   106,   106,    20,   105,   105,   125,
     113,   114,   115,   116,   117,   118,   106,    46,   106,   108,
     111,   108,   126,   126,   127,   128,     1,   111,     3,     4,
       5,     6,     7,     8,     9,    10,    83,    83,    92,   108,
      15,    16,   108,    18,   126,    20,    21,    61,    23,    24,
      64,    65,    66,    67,    68,   126,    70,    71,    72,    73,
      74,    75,    76,    77,   126,   432,   126,   111,    43,    44,
      45,   111,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,   277,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,   276,    84,
      85,    86,    87,    88,    89,    90,    91,   278,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   279,   184,   127,   280,   103,    78,    31,   113,   114,
     115,   116,   117,   118,   352,    97,   348,   224,   409,   106,
     414,   126,   127,   128,     1,   495,     3,     4,     5,     6,
       7,     8,     9,    10,   438,   545,    46,   303,    15,    16,
     440,    18,    -1,    20,    21,    -1,    23,    24,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,     0,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    20,   113,   114,   115,   116,
     117,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   126,
     127,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,
      -1,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    20,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,     3,     4,     5,     6,     7,     8,     9,
      10,   126,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,
      -1,    21,    -1,    23,    24,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    -1,    18,    43,    44,    21,    -1,    23,    24,    -1,
      -1,   126,    -1,    -1,    -1,    55,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    78,    79,
      15,    16,    -1,    18,    -1,    -1,    21,    87,    23,    24,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,   105,    -1,    -1,    43,    44,
      -1,    87,    -1,   113,   114,   115,   116,   117,   118,    -1,
      55,    56,    -1,    -1,    -1,    -1,    -1,   127,   128,   105,
      -1,    -1,   108,    -1,    -1,    -1,    -1,   113,   114,   115,
     116,   117,   118,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    87,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,
     105,    20,    21,    -1,    23,    24,    -1,    -1,   113,   114,
     115,   116,   117,   118,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   127,    -1,    43,    44,    -1,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    -1,    18,    -1,   105,    21,    -1,    23,
      24,    -1,    -1,    -1,   113,   114,   115,   116,   117,   118,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   126,    -1,    43,
      44,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    55,    56,    15,    16,    -1,    18,    -1,    -1,    21,
      -1,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    43,    44,    87,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    55,    56,    -1,    15,    16,    -1,    18,
      -1,   105,    21,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,   115,   116,   117,   118,    -1,    78,    79,    -1,    -1,
      -1,    -1,   126,    -1,    -1,    87,    -1,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,   105,    18,    -1,    20,    21,    -1,    23,
      24,   113,   114,   115,   116,   117,   118,    -1,    -1,    78,
      79,    -1,    -1,    -1,   126,    -1,    -1,    -1,    87,    43,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      -1,    55,    56,    -1,    -1,    59,   105,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    87,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,
      -1,   105,    21,    -1,    23,    24,    -1,    -1,    -1,   113,
     114,   115,   116,   117,   118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    44,    -1,    48,    -1,    50,
      51,    52,    53,    -1,    55,    56,    55,    56,    59,    -1,
      -1,    62,    63,    -1,    -1,    -1,    -1,     1,    69,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    78,
      79,    15,    16,    -1,    18,    -1,    -1,    21,    87,    23,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,    -1,    43,
      44,    -1,    -1,   114,   113,   114,   115,   116,   117,   118,
      -1,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    78,    79,    15,    16,    -1,    18,
      -1,    -1,    21,    87,    23,    24,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    43,    44,    -1,    -1,    -1,   113,
     114,   115,   116,   117,   118,    -1,    55,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    -1,    18,    -1,   105,    21,    -1,    23,
      24,    -1,    -1,    -1,   113,   114,   115,   116,   117,   118,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      44,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    55,    56,    15,    16,    -1,    18,    -1,    -1,    21,
      -1,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    43,    44,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    56,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,   115,   116,   117,   118,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    -1,    18,   105,   106,    21,    -1,    23,    24,    -1,
      -1,   113,   114,   115,   116,   117,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    44,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    55,
      56,    15,    16,    -1,    18,    -1,    -1,    21,    -1,    23,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    43,
      44,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,   115,
     116,   117,   118,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,
      18,   105,   106,    21,    -1,    23,    24,    -1,    -1,   113,
     114,   115,   116,   117,   118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    44,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    55,    56,    15,
      16,    -1,    18,    -1,    -1,    21,    -1,    23,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    43,    44,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      56,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,   115,   116,   117,
     118,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,   105,
     106,    21,    -1,    23,    24,    -1,    -1,   113,   114,   115,
     116,   117,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    44,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    55,    56,    15,    16,    -1,
      18,    -1,    -1,    21,    -1,    23,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    43,    44,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   114,   115,   116,   117,   118,    -1,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    -1,    18,   105,   106,    21,
      -1,    23,    24,    -1,    -1,   113,   114,   115,   116,   117,
     118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    44,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    55,    56,    15,    16,    -1,    18,    -1,
      -1,    21,    -1,    23,    24,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    43,    44,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    56,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,    -1,    -1,    -1,    -1,    -1,
      -1,   113,   114,   115,   116,   117,   118,    -1,    78,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    -1,    18,   105,   106,    21,    -1,    23,
      24,    -1,    -1,   113,   114,   115,   116,   117,   118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      44,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    55,    56,    15,    16,    -1,    18,    -1,    -1,    21,
      -1,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    43,    44,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    56,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,   115,   116,   117,   118,    -1,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      -1,    18,    -1,   105,    21,    -1,    23,    24,    -1,    -1,
      -1,   113,   114,   115,   116,   117,   118,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    43,    -1,    -1,    -1,
      15,    16,    -1,    18,    -1,    -1,    21,    -1,    23,    24,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    -1,    18,    -1,   105,    21,
      -1,   108,    -1,    78,    79,    -1,   113,   114,   115,   116,
     117,   118,    87,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,
     105,    -1,    21,   108,    23,    24,    -1,    -1,   113,   114,
     115,   116,   117,   118,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    43,    -1,    78,    79,    15,    16,
      -1,    18,    -1,    -1,    21,    87,    23,    24,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,   105,    18,   107,    43,    21,   110,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    -1,    18,    -1,   105,    21,    -1,    23,
      24,    78,    79,    -1,   113,   114,   115,   116,   117,   118,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,   105,    -1,
      -1,    -1,    -1,    87,    -1,    -1,   113,   114,   115,   116,
     117,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      -1,   105,    -1,   107,    78,    79,   110,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    18,    -1,    20,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
     114,   115,   116,   117,   118,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,     1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    20,    18,    -1,    -1,    21,
      -1,    -1,    -1,   105,   106,   107,    -1,    -1,    -1,    -1,
      -1,   113,   114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    20,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,   107,   105,    -1,   107,    -1,    -1,   113,   114,
      48,    -1,    50,    51,    52,    53,    20,    55,    56,    -1,
      -1,    59,    -1,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      20,    55,    56,    -1,    -1,    59,    -1,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    -1,    48,    -1,
      50,    51,    52,    53,    20,    55,    56,    -1,    -1,    59,
     128,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    -1,    55,
      56,    -1,    -1,    59,   128,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   128,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   128,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,     1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    55,    56,    20,    58,    -1,    -1,    61,    -1,    -1,
      64,    65,    66,    67,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    -1,    -1,   106,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    20,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    -1,    50,    51,    52,
      53,    -1,    55,    56,    -1,    -1,    59,    -1,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,    20,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,   126,   156,   157,   160,   161,   164,   165,
     167,   170,   171,   172,   179,   182,   231,   232,   233,   126,
      17,   127,   105,   110,    18,   127,   178,    47,    48,   161,
     161,    18,   105,   113,   114,   126,   162,   163,   184,   186,
     187,   188,   161,   110,   161,   127,    18,    20,   127,   169,
     161,     0,   232,   127,   165,   166,    18,   158,   159,     3,
       5,     7,     9,   185,   178,   180,   181,   127,    17,   184,
     182,   183,   187,   109,   126,   125,   234,   105,   107,   186,
     186,   185,   128,   165,   167,   168,   173,   174,   175,   182,
     128,   173,   156,   161,   109,   128,   106,   109,   111,   125,
     109,   128,   180,   106,   182,   187,   163,   184,     3,     4,
       5,     6,     7,     8,     9,    10,    15,    16,    18,    21,
      23,    24,    43,    44,    55,    56,    78,    79,    87,   105,
     113,   114,   115,   116,   117,   118,   127,   131,   132,   133,
     134,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   151,   152,   195,   127,   199,
     201,     1,   106,   161,   189,   190,   191,     1,   108,   136,
     148,   154,   111,   175,   110,   128,   174,   176,   177,   184,
     175,   128,   128,   165,   126,   158,   154,   128,   181,   109,
     128,   105,   136,   136,   105,   136,    44,    44,   107,   110,
     133,     1,    55,    56,   152,   153,   175,   192,   136,   136,
     137,   137,   137,   137,   195,   196,    22,    23,    24,   105,
     107,   112,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,   125,   114,   119,   120,   115,   116,    25,    26,
      27,    28,   110,   111,    29,    30,   113,   121,   122,    31,
      32,   123,    55,    56,   150,   157,   165,   128,     1,    18,
      45,    59,    80,    81,    82,    84,    85,    86,    88,    89,
      90,    91,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   126,   153,   155,   156,   197,   198,
     201,   202,   203,   204,   207,   208,   209,   210,   212,   217,
     219,   224,   225,   226,   227,   228,   229,   230,   106,   109,
     105,   107,   184,   187,   188,   193,   194,   106,   109,   108,
     108,   185,   109,   126,   128,   192,   152,   133,   105,   106,
     106,   109,   105,   187,   188,   193,   106,   109,   128,    18,
       1,   106,   135,   152,     1,   153,    18,   152,   152,   152,
     152,   152,   152,   152,   152,   152,   152,   152,   137,   137,
     137,   138,   138,   139,   139,   140,   140,   140,   140,   141,
     141,   142,   143,   144,   145,   146,   153,   165,   165,   105,
     107,   165,   126,   153,   127,   154,   124,   105,   105,   105,
     197,    18,   224,   126,   126,   126,   153,   105,   197,   105,
     126,   105,   105,   126,   128,   197,   200,   105,   105,   105,
     105,   105,   105,   124,     1,   106,   189,   193,   108,   154,
     125,   194,   194,   105,   107,   191,   111,   177,   106,   108,
     109,   105,   106,   135,   152,   137,   128,   195,   106,   106,
     109,   108,   108,   124,   196,   153,   126,   202,   124,   197,
     153,   153,   153,    85,   126,   126,   153,    85,   153,    19,
     130,   130,   155,   203,   206,   206,    18,   211,   215,   216,
     216,    18,   213,    18,   218,   197,   106,   106,   108,   195,
     106,   189,   108,   154,   107,   110,   133,   152,   106,   135,
     106,   152,   148,   106,   109,   108,   128,   197,   106,   106,
     106,   105,   106,   105,   106,    19,   106,   109,   109,   126,
     153,   205,   205,   125,   106,   109,   106,   106,    46,   106,
     108,   152,   133,   105,   108,   109,   111,   106,   197,   197,
     197,   153,   197,   153,   197,   126,   135,   153,   126,   106,
     153,   106,   153,    11,    12,    13,    14,   152,   214,   220,
     215,   221,   222,   153,   108,   105,   106,   135,   133,   152,
     111,    83,   106,    83,   106,   106,   106,   197,   106,   197,
     106,    92,   152,   197,   197,   197,   106,   107,   133,   106,
     135,   106,   105,   108,   197,   126,   197,   126,   126,   126,
     197,   197,   152,   223,   152,   105,   111,   106,   106,   135,
     133,   197,   108,   106,   135,   111,   106,   105,   133,   106,
     106,   135,   105,   106,   106,   135,   106
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   129,   130,   130,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   133,   133,   133,   133,
     133,   133,   133,   133,   134,   134,   134,   134,   135,   135,
     136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   137,   137,   138,   138,   138,   138,   139,   139,   139,
     140,   140,   140,   141,   141,   141,   141,   141,   142,   142,
     142,   143,   143,   144,   144,   145,   145,   146,   146,   147,
     147,   148,   148,   149,   149,   149,   150,   150,   150,   150,
     151,   151,   151,   151,   152,   152,   152,   152,   152,   152,
     152,   152,   152,   152,   152,   152,   153,   153,   154,   155,
     156,   156,   157,   158,   159,   159,   160,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   162,   162,
     163,   163,   164,   164,   164,   164,   165,   165,   165,   165,
     166,   166,   167,   167,   167,   167,   167,   167,   167,   167,
     167,   167,   167,   167,   168,   169,   169,   170,   171,   171,
     171,   171,   171,   172,   173,   173,   174,   175,   175,   175,
     175,   176,   176,   177,   178,   179,   179,   179,   179,   179,
     180,   180,   181,   181,   182,   182,   182,   182,   182,   182,
     182,   182,   182,   182,   182,   183,   183,   184,   184,   184,
     185,   185,   185,   185,   186,   186,   186,   186,   186,   186,
     186,   186,   187,   187,   187,   187,   188,   189,   190,   190,
     190,   191,   191,   191,   191,   192,   192,   193,   193,   193,
     193,   193,   194,   194,   194,   194,   194,   194,   194,   194,
     194,   195,   195,   195,   196,   196,   197,   197,   197,   197,
     197,   197,   197,   197,   197,   197,   197,   197,   197,   198,
     198,   198,   199,   200,   201,   201,   202,   202,   203,   203,
     204,   204,   204,   204,   204,   205,   205,   206,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   214,   214,   214,
     215,   215,   216,   216,   217,   218,   219,   219,   219,   219,
     219,   219,   219,   219,   220,   219,   221,   219,   222,   219,
     223,   219,   224,   225,   225,   225,   225,   225,   226,   227,
     228,   229,   229,   230,   231,   231,   231,   232,   232,   232,
     232,   232,   234,   233
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       5,     4,     8,     7,    10,     9,    11,    10,    12,    11,
      14,    13,     7,     6,    10,     9,     1,     4,     4,     1,
       3,     3,     2,     2,     1,     3,     4,     4,     1,     3,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     1,     4,     1,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     3,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     5,     1,     2,     2,     1,     2,     2,     2,
       1,     2,     5,     5,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     3,     1,     1,
       2,     3,     4,     1,     1,     3,     4,     1,     2,     1,
       2,     1,     2,     1,     4,     2,     1,     2,     1,     3,
       1,     3,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     1,     1,     2,     1,     4,
       4,     3,     3,     1,     1,     2,     3,     2,     1,     1,
       2,     1,     3,     1,     1,     4,     5,     5,     6,     2,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     3,     4,     3,     4,     4,
       3,     4,     1,     2,     2,     3,     1,     1,     1,     3,
       2,     2,     4,     2,     1,     1,     2,     1,     1,     2,
       1,     2,     3,     2,     3,     3,     4,     2,     3,     3,
       4,     1,     3,     4,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     3,
       4,     3,     1,     1,     2,     3,     1,     2,     1,     2,
       5,     7,     5,     7,     5,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       5,     4,     1,     3,     1,     1,     5,     5,     7,     7,
       6,     7,     6,     7,     0,     6,     0,     6,     0,     6,
       0,     8,     1,     3,     2,     2,     2,     3,     2,     3,
       4,     5,     7,     7,     1,     2,     2,     1,     5,     5,
       1,     1,     0,     4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* string_constant: TOKEN_STRING_LITERAL  */
#line 265 "src/parse.yy"
                           { (yyval.stringVal) = new std::string(*yylval.stringVal); }
#line 2779 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 3: /* string_constant: string_constant TOKEN_STRING_LITERAL  */
#line 267 "src/parse.yy"
    {
        std::string s = *((std::string *)(yyvsp[-1].stringVal));
        s += *yylval.stringVal;
        (yyval.stringVal) = new std::string(s);
    }
#line 2789 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 4: /* primary_expression: TOKEN_IDENTIFIER  */
#line 275 "src/parse.yy"
                       {
        const char *name = yylval.stringVal->c_str();
        Symbol *s = m->symbolTable->LookupVariable(name);
        (yyval.expr) = NULL;
        if (s)
            (yyval.expr) = new SymbolExpr(s, (yylsp[0]));
        else {
            std::vector<Symbol *> funs;
            m->symbolTable->LookupFunction(name, &funs);
            if (funs.size() > 0)
                (yyval.expr) = new FunctionSymbolExpr(name, funs, (yylsp[0]));
        }
        if ((yyval.expr) == NULL) {
            std::vector<std::string> alternates =
                m->symbolTable->ClosestVariableOrFunctionMatch(name);
            std::string alts = lGetAlternates(alternates);
            Error((yylsp[0]), "Undeclared symbol \"%s\".%s", name, alts.c_str());
        }
    }
#line 2813 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 5: /* primary_expression: TOKEN_INT8_CONSTANT  */
#line 294 "src/parse.yy"
                          {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt8->GetAsConstType(),
                           (int8_t)yylval.intVal, (yylsp[0]));
    }
#line 2822 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 6: /* primary_expression: TOKEN_UINT8_CONSTANT  */
#line 298 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt8->GetAsConstType(),
                           (uint8_t)yylval.intVal, (yylsp[0]));
    }
#line 2831 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 7: /* primary_expression: TOKEN_INT16_CONSTANT  */
#line 302 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt16->GetAsConstType(),
                           (int16_t)yylval.intVal, (yylsp[0]));
    }
#line 2840 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 8: /* primary_expression: TOKEN_UINT16_CONSTANT  */
#line 306 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt16->GetAsConstType(),
                           (uint16_t)yylval.intVal, (yylsp[0]));
    }
#line 2849 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 9: /* primary_expression: TOKEN_INT32_CONSTANT  */
#line 310 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 2858 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 10: /* primary_expression: TOKEN_UINT32_CONSTANT  */
#line 314 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 2867 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 11: /* primary_expression: TOKEN_INT64_CONSTANT  */
#line 318 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 2876 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 12: /* primary_expression: TOKEN_UINT64_CONSTANT  */
#line 322 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 2885 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 13: /* primary_expression: TOKEN_FLOAT_CONSTANT  */
#line 326 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformFloat->GetAsConstType(),
                           yylval.floatVal, (yylsp[0]));
    }
#line 2894 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 14: /* primary_expression: TOKEN_DOUBLE_CONSTANT  */
#line 330 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformDouble->GetAsConstType(),
                           yylval.doubleVal, (yylsp[0]));
    }
#line 2903 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 15: /* primary_expression: TOKEN_TRUE  */
#line 334 "src/parse.yy"
                 {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), true, (yylsp[0]));
    }
#line 2911 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 16: /* primary_expression: TOKEN_FALSE  */
#line 337 "src/parse.yy"
                  {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), false, (yylsp[0]));
    }
#line 2919 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 17: /* primary_expression: TOKEN_NULL  */
#line 340 "src/parse.yy"
                 {
        (yyval.expr) = new NullPointerExpr((yylsp[0]));
    }
#line 2927 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 18: /* primary_expression: '(' expression ')'  */
#line 345 "src/parse.yy"
                         { (yyval.expr) = (yyvsp[-1].expr); }
#line 2933 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 19: /* primary_expression: '(' error ')'  */
#line 346 "src/parse.yy"
                    { (yyval.expr) = NULL; }
#line 2939 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 20: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' argument_expression_list ')'  */
#line 351 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]), (yylsp[0])), true, launchCount);
      }
#line 2949 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 21: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' ')'  */
#line 357 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-1]),(yylsp[0]))), Union((yylsp[-2]), (yylsp[0])), true, launchCount);
       }
#line 2959 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 22: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 364 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 2969 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 23: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 370 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 2979 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 24: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 377 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-7].expr), (yyvsp[-5].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 2989 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 25: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 383 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-6].expr), (yyvsp[-4].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 2999 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 26: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 389 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3009 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 27: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 395 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3019 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 28: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 402 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-9].expr), (yyvsp[-7].expr), (yyvsp[-5].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3028 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 29: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 407 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3037 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 30: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 412 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), (yyvsp[-11].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3046 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 31: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 417 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), (yyvsp[-10].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3055 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 32: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 424 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3065 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 33: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' ')' '>'  */
#line 430 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3075 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 34: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 436 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3085 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 35: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' ')' '>'  */
#line 442 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3095 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 37: /* postfix_expression: postfix_expression '[' expression ']'  */
#line 452 "src/parse.yy"
      { (yyval.expr) = new IndexExpr((yyvsp[-3].expr), (yyvsp[-1].expr), Union((yylsp[-3]),(yylsp[0]))); }
#line 3101 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 38: /* postfix_expression: postfix_expression '[' error ']'  */
#line 454 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3107 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 40: /* postfix_expression: postfix_expression '.' TOKEN_IDENTIFIER  */
#line 457 "src/parse.yy"
      { (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false); }
#line 3113 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 41: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_IDENTIFIER  */
#line 459 "src/parse.yy"
      { (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true); }
#line 3119 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 42: /* postfix_expression: postfix_expression TOKEN_INC_OP  */
#line 461 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostInc, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3125 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 43: /* postfix_expression: postfix_expression TOKEN_DEC_OP  */
#line 463 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostDec, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3131 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 45: /* funcall_expression: postfix_expression '(' ')'  */
#line 469 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0]))); }
#line 3137 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 46: /* funcall_expression: postfix_expression '(' argument_expression_list ')'  */
#line 471 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0]))); }
#line 3143 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 47: /* funcall_expression: postfix_expression '(' error ')'  */
#line 473 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3149 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 48: /* argument_expression_list: assignment_expression  */
#line 477 "src/parse.yy"
                                 { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 3155 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 49: /* argument_expression_list: argument_expression_list ',' assignment_expression  */
#line 479 "src/parse.yy"
      {
          ExprList *argList = llvm::dyn_cast<ExprList>((yyvsp[-2].exprList));
          if (argList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              argList = new ExprList((yylsp[0]));
          }
          argList->exprs.push_back((yyvsp[0].expr));
          argList->pos = Union(argList->pos, (yylsp[0]));
          (yyval.exprList) = argList;
      }
#line 3170 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 51: /* unary_expression: TOKEN_INC_OP unary_expression  */
#line 494 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreInc, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3176 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 52: /* unary_expression: TOKEN_DEC_OP unary_expression  */
#line 496 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreDec, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3182 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 53: /* unary_expression: '&' unary_expression  */
#line 498 "src/parse.yy"
      { (yyval.expr) = new AddressOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3188 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 54: /* unary_expression: '*' unary_expression  */
#line 500 "src/parse.yy"
      { (yyval.expr) = new PtrDerefExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3194 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 55: /* unary_expression: '+' cast_expression  */
#line 502 "src/parse.yy"
      { (yyval.expr) = (yyvsp[0].expr); }
#line 3200 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 56: /* unary_expression: '-' cast_expression  */
#line 504 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::Negate, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3206 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 57: /* unary_expression: '~' cast_expression  */
#line 506 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::BitNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3212 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 58: /* unary_expression: '!' cast_expression  */
#line 508 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::LogicalNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3218 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 59: /* unary_expression: TOKEN_SIZEOF unary_expression  */
#line 510 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3224 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 60: /* unary_expression: TOKEN_SIZEOF '(' type_name ')'  */
#line 512 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[-1].type), Union((yylsp[-3]), (yylsp[0]))); }
#line 3230 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 62: /* cast_expression: '(' type_name ')' cast_expression  */
#line 518 "src/parse.yy"
      {
          (yyval.expr) = new TypeCastExpr((yyvsp[-2].type), (yyvsp[0].expr), Union((yylsp[-3]),(yylsp[0])));
      }
#line 3238 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 64: /* multiplicative_expression: multiplicative_expression '*' cast_expression  */
#line 526 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mul, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3244 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 65: /* multiplicative_expression: multiplicative_expression '/' cast_expression  */
#line 528 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Div, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3250 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 66: /* multiplicative_expression: multiplicative_expression '%' cast_expression  */
#line 530 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mod, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3256 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 68: /* additive_expression: additive_expression '+' multiplicative_expression  */
#line 536 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Add, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3262 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 69: /* additive_expression: additive_expression '-' multiplicative_expression  */
#line 538 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Sub, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3268 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 71: /* shift_expression: shift_expression TOKEN_LEFT_OP additive_expression  */
#line 544 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shl, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3274 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 72: /* shift_expression: shift_expression TOKEN_RIGHT_OP additive_expression  */
#line 546 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3280 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 74: /* relational_expression: relational_expression '<' shift_expression  */
#line 552 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Lt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3286 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 75: /* relational_expression: relational_expression '>' shift_expression  */
#line 554 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Gt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3292 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 76: /* relational_expression: relational_expression TOKEN_LE_OP shift_expression  */
#line 556 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Le, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3298 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 77: /* relational_expression: relational_expression TOKEN_GE_OP shift_expression  */
#line 558 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Ge, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3304 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 79: /* equality_expression: equality_expression TOKEN_EQ_OP relational_expression  */
#line 564 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Equal, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3310 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 80: /* equality_expression: equality_expression TOKEN_NE_OP relational_expression  */
#line 566 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::NotEqual, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3316 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 82: /* and_expression: and_expression '&' equality_expression  */
#line 572 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3322 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 84: /* exclusive_or_expression: exclusive_or_expression '^' and_expression  */
#line 578 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitXor, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3328 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 86: /* inclusive_or_expression: inclusive_or_expression '|' exclusive_or_expression  */
#line 584 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3334 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 88: /* logical_and_expression: logical_and_expression TOKEN_AND_OP inclusive_or_expression  */
#line 590 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3340 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 90: /* logical_or_expression: logical_or_expression TOKEN_OR_OP logical_and_expression  */
#line 596 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3346 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 92: /* conditional_expression: logical_or_expression '?' expression ':' conditional_expression  */
#line 602 "src/parse.yy"
      { (yyval.expr) = new SelectExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-4]),(yylsp[0]))); }
#line 3352 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 93: /* rate_qualified_new: TOKEN_NEW  */
#line 606 "src/parse.yy"
                { (yyval.intVal) = 0; }
#line 3358 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 94: /* rate_qualified_new: TOKEN_UNIFORM TOKEN_NEW  */
#line 607 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_UNIFORM; }
#line 3364 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 95: /* rate_qualified_new: TOKEN_VARYING TOKEN_NEW  */
#line 608 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_VARYING; }
#line 3370 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 96: /* rate_qualified_type_specifier: type_specifier  */
#line 612 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].type); }
#line 3376 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 97: /* rate_qualified_type_specifier: TOKEN_UNIFORM type_specifier  */
#line 614 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
            (yyval.type) = NULL;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
    }
#line 3391 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 98: /* rate_qualified_type_specifier: TOKEN_VARYING type_specifier  */
#line 625 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
            (yyval.type) = NULL;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
    }
#line 3406 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 99: /* rate_qualified_type_specifier: soa_width_specifier type_specifier  */
#line 636 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else {
            int soaWidth = (int)(yyvsp[-1].intVal);
            const StructType *st = CastType<StructType>((yyvsp[0].type));
            if (st == NULL) {
                Error((yylsp[-1]), "\"soa\" qualifier is illegal with non-struct type \"%s\".",
                      (yyvsp[0].type)->GetString().c_str());
                (yyval.type) = NULL;
            }
            else if (soaWidth <= 0 || (soaWidth & (soaWidth - 1)) != 0) {
                Error((yylsp[-1]), "soa<%d> width illegal. Value must be positive power "
                      "of two.", soaWidth);
                (yyval.type) = NULL;
            }
            else
                (yyval.type) = st->GetAsSOAType(soaWidth);
        }
    }
#line 3431 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 101: /* new_expression: rate_qualified_new rate_qualified_type_specifier  */
#line 661 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-1].intVal), (yyvsp[0].type), NULL, NULL, (yylsp[-1]), Union((yylsp[-1]), (yylsp[0])));
    }
#line 3439 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 102: /* new_expression: rate_qualified_new rate_qualified_type_specifier '(' initializer_list ')'  */
#line 665 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), (yyvsp[-1].exprList), NULL, (yylsp[-4]), Union((yylsp[-4]), (yylsp[-3])));
    }
#line 3447 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 103: /* new_expression: rate_qualified_new rate_qualified_type_specifier '[' expression ']'  */
#line 669 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), NULL, (yyvsp[-1].expr), (yylsp[-4]), Union((yylsp[-4]), (yylsp[-1])));
    }
#line 3455 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 105: /* assignment_expression: unary_expression '=' assignment_expression  */
#line 677 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::Assign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3461 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 106: /* assignment_expression: unary_expression TOKEN_MUL_ASSIGN assignment_expression  */
#line 679 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::MulAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3467 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 107: /* assignment_expression: unary_expression TOKEN_DIV_ASSIGN assignment_expression  */
#line 681 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::DivAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3473 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 108: /* assignment_expression: unary_expression TOKEN_MOD_ASSIGN assignment_expression  */
#line 683 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ModAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3479 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 109: /* assignment_expression: unary_expression TOKEN_ADD_ASSIGN assignment_expression  */
#line 685 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AddAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3485 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 110: /* assignment_expression: unary_expression TOKEN_SUB_ASSIGN assignment_expression  */
#line 687 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::SubAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3491 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 111: /* assignment_expression: unary_expression TOKEN_LEFT_ASSIGN assignment_expression  */
#line 689 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShlAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3497 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 112: /* assignment_expression: unary_expression TOKEN_RIGHT_ASSIGN assignment_expression  */
#line 691 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3503 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 113: /* assignment_expression: unary_expression TOKEN_AND_ASSIGN assignment_expression  */
#line 693 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AndAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3509 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 114: /* assignment_expression: unary_expression TOKEN_XOR_ASSIGN assignment_expression  */
#line 695 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::XorAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3515 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 115: /* assignment_expression: unary_expression TOKEN_OR_ASSIGN assignment_expression  */
#line 697 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::OrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3521 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 117: /* expression: expression ',' assignment_expression  */
#line 703 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Comma, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3527 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 119: /* declaration_statement: declaration  */
#line 712 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) == NULL) {
            AssertPos((yylsp[0]), m->errorCount > 0);
            (yyval.stmt) = NULL;
        }
        else if ((yyvsp[0].declaration)->declSpecs->storageClass == SC_TYPEDEF) {
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i) {
                if ((yyvsp[0].declaration)->declarators[i] == NULL)
                    AssertPos((yylsp[0]), m->errorCount > 0);
                else
                    m->AddTypeDef((yyvsp[0].declaration)->declarators[i]->name,
                                  (yyvsp[0].declaration)->declarators[i]->type,
                                  (yyvsp[0].declaration)->declarators[i]->pos);
            }
            (yyval.stmt) = NULL;
        }
        else {
            (yyvsp[0].declaration)->DeclareFunctions();
            std::vector<VariableDeclaration> vars = (yyvsp[0].declaration)->GetVariableDeclarations();
            (yyval.stmt) = new DeclStmt(vars, (yylsp[0]));
        }
    }
#line 3554 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 120: /* declaration: declaration_specifiers ';'  */
#line 738 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs));
      }
#line 3562 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 121: /* declaration: declaration_specifiers init_declarator_list ';'  */
#line 742 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-2].declSpecs), (yyvsp[-1].declarators));
      }
#line 3570 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 122: /* soa_width_specifier: TOKEN_SOA '<' int_constant '>'  */
#line 749 "src/parse.yy"
      { (yyval.intVal) = (yyvsp[-1].intVal); }
#line 3576 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 123: /* declspec_item: TOKEN_IDENTIFIER  */
#line 754 "src/parse.yy"
    {
        std::pair<std::string, SourcePos> *p = new std::pair<std::string, SourcePos>;
        p->first = *(yylval.stringVal);
        p->second = (yylsp[0]);
        (yyval.declspecPair) = p;
    }
#line 3587 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 124: /* declspec_list: declspec_item  */
#line 764 "src/parse.yy"
    {
        (yyval.declspecList) = new std::vector<std::pair<std::string, SourcePos> >;
        (yyval.declspecList)->push_back(*(yyvsp[0].declspecPair));
    }
#line 3596 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 125: /* declspec_list: declspec_list ',' declspec_item  */
#line 769 "src/parse.yy"
    {
        if ((yyvsp[-2].declspecList) != NULL)
            (yyvsp[-2].declspecList)->push_back(*(yyvsp[0].declspecPair));
        (yyval.declspecList) = (yyvsp[-2].declspecList);
    }
#line 3606 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 126: /* declspec_specifier: TOKEN_DECLSPEC '(' declspec_list ')'  */
#line 778 "src/parse.yy"
    {
        (yyval.declspecList) = (yyvsp[-1].declspecList);
    }
#line 3614 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 127: /* declaration_specifiers: storage_class_specifier  */
#line 785 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(NULL, (yyvsp[0].storageClass));
      }
#line 3622 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 128: /* declaration_specifiers: storage_class_specifier declaration_specifiers  */
#line 789 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->storageClass != SC_NONE)
                  Error((yylsp[-1]), "Multiple storage class specifiers in a declaration are illegal. "
                        "(Have provided both \"%s\" and \"%s\".)",
                        lGetStorageClassString(ds->storageClass),
                        lGetStorageClassString((yyvsp[-1].storageClass)));
              else
                  ds->storageClass = (yyvsp[-1].storageClass);
          }
          (yyval.declSpecs) = ds;
      }
#line 3640 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 129: /* declaration_specifiers: declspec_specifier  */
#line 803 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs;
          if ((yyvsp[0].declspecList) != NULL)
              (yyval.declSpecs)->declSpecList = *(yyvsp[0].declspecList);
      }
#line 3650 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 130: /* declaration_specifiers: declspec_specifier declaration_specifiers  */
#line 809 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          std::vector<std::pair<std::string, SourcePos> > *declSpecList = (yyvsp[-1].declspecList);
          if (ds != NULL && declSpecList != NULL) {
              for (int i = 0; i < (int)declSpecList->size(); ++i)
                  ds->declSpecList.push_back((*declSpecList)[i]);
          }
          (yyval.declSpecs) = ds;
      }
#line 3664 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 131: /* declaration_specifiers: soa_width_specifier  */
#line 819 "src/parse.yy"
      {
          DeclSpecs *ds = new DeclSpecs;
          ds->soaWidth = (int32_t)(yyvsp[0].intVal);
          (yyval.declSpecs) = ds;
      }
#line 3674 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 132: /* declaration_specifiers: soa_width_specifier declaration_specifiers  */
#line 825 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->soaWidth != 0)
                  Error((yylsp[-1]), "soa<> qualifier supplied multiple times in declaration.");
              else
                  ds->soaWidth = (int32_t)(yyvsp[-1].intVal);
          }
          (yyval.declSpecs) = ds;
      }
#line 3689 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 133: /* declaration_specifiers: type_specifier  */
#line 836 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs((yyvsp[0].type));
      }
#line 3697 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 134: /* declaration_specifiers: type_specifier '<' int_constant '>'  */
#line 840 "src/parse.yy"
    {
          DeclSpecs *ds = new DeclSpecs((yyvsp[-3].type));
          ds->vectorSize = (int32_t)(yyvsp[-1].intVal);
          (yyval.declSpecs) = ds;
    }
#line 3707 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 135: /* declaration_specifiers: type_specifier declaration_specifiers  */
#line 846 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->baseType != NULL) {
                  if( ds->baseType->IsUnsignedType()) {
                      Error((yylsp[-1]), "Redefining uint8/uint16/uint32/uint64 type "
                      "which is part of ISPC language since version 1.13. "
                      "Remove this typedef or use ISPC_UINT_IS_DEFINED to "
                      "detect that these types are defined.");
                  }
                  else
                      Error((yylsp[-1]), "Multiple types provided for declaration.");
              }
              ds->baseType = (yyvsp[-1].type);
          }
          (yyval.declSpecs) = ds;
      }
#line 3729 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 136: /* declaration_specifiers: type_qualifier  */
#line 864 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(NULL, SC_NONE, (yyvsp[0].typeQualifier));
      }
#line 3737 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 137: /* declaration_specifiers: type_qualifier declaration_specifiers  */
#line 868 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL)
              ds->typeQualifiers |= (yyvsp[-1].typeQualifier);
          (yyval.declSpecs) = ds;
      }
#line 3748 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 138: /* init_declarator_list: init_declarator  */
#line 878 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != NULL)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 3759 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 139: /* init_declarator_list: init_declarator_list ',' init_declarator  */
#line 885 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = (std::vector<Declarator *> *)(yyvsp[-2].declarators);
          if (dl == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              dl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != NULL)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 3774 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 141: /* init_declarator: declarator '=' initializer  */
#line 900 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != NULL)
              (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
          (yyval.declarator) = (yyvsp[-2].declarator);
      }
#line 3784 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 142: /* storage_class_specifier: TOKEN_TYPEDEF  */
#line 908 "src/parse.yy"
                    { (yyval.storageClass) = SC_TYPEDEF; }
#line 3790 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 143: /* storage_class_specifier: TOKEN_EXTERN  */
#line 909 "src/parse.yy"
                   { (yyval.storageClass) = SC_EXTERN; }
#line 3796 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 144: /* storage_class_specifier: TOKEN_EXTERN TOKEN_STRING_C_LITERAL  */
#line 910 "src/parse.yy"
                                           { (yyval.storageClass) = SC_EXTERN_C; }
#line 3802 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 145: /* storage_class_specifier: TOKEN_STATIC  */
#line 911 "src/parse.yy"
                   { (yyval.storageClass) = SC_STATIC; }
#line 3808 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 146: /* type_specifier: atomic_var_type_specifier  */
#line 915 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].atomicType); }
#line 3814 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 147: /* type_specifier: TOKEN_TYPE_NAME  */
#line 917 "src/parse.yy"
    {
        const Type *t = m->symbolTable->LookupType(yytext);
        (yyval.type) = t;
    }
#line 3823 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 148: /* type_specifier: struct_or_union_specifier  */
#line 921 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].type); }
#line 3829 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 149: /* type_specifier: enum_specifier  */
#line 922 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].enumType); }
#line 3835 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 150: /* type_specifier_list: type_specifier  */
#line 927 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.typeList) = NULL;
        else {
            std::vector<std::pair<const Type *, SourcePos> > *vec =
                new std::vector<std::pair<const Type *, SourcePos> >;
            vec->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
            (yyval.typeList) = vec;
        }
    }
#line 3850 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 151: /* type_specifier_list: type_specifier_list ',' type_specifier  */
#line 938 "src/parse.yy"
    {
        (yyval.typeList) = (yyvsp[-2].typeList);
        if ((yyvsp[-2].typeList) == NULL)
            Assert(m->errorCount > 0);
        else
            (yyval.typeList)->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
    }
#line 3862 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 152: /* atomic_var_type_specifier: TOKEN_VOID  */
#line 948 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::Void; }
#line 3868 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 153: /* atomic_var_type_specifier: TOKEN_BOOL  */
#line 949 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformBool->GetAsUnboundVariabilityType(); }
#line 3874 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 154: /* atomic_var_type_specifier: TOKEN_INT8  */
#line 950 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformInt8->GetAsUnboundVariabilityType(); }
#line 3880 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 155: /* atomic_var_type_specifier: TOKEN_UINT8  */
#line 951 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformUInt8->GetAsUnboundVariabilityType(); }
#line 3886 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 156: /* atomic_var_type_specifier: TOKEN_INT16  */
#line 952 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt16->GetAsUnboundVariabilityType(); }
#line 3892 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 157: /* atomic_var_type_specifier: TOKEN_UINT16  */
#line 953 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt16->GetAsUnboundVariabilityType(); }
#line 3898 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 158: /* atomic_var_type_specifier: TOKEN_INT  */
#line 954 "src/parse.yy"
                { (yyval.atomicType) = AtomicType::UniformInt32->GetAsUnboundVariabilityType(); }
#line 3904 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 159: /* atomic_var_type_specifier: TOKEN_UINT  */
#line 955 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformUInt32->GetAsUnboundVariabilityType(); }
#line 3910 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 160: /* atomic_var_type_specifier: TOKEN_FLOAT  */
#line 956 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformFloat->GetAsUnboundVariabilityType(); }
#line 3916 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 161: /* atomic_var_type_specifier: TOKEN_DOUBLE  */
#line 957 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformDouble->GetAsUnboundVariabilityType(); }
#line 3922 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 162: /* atomic_var_type_specifier: TOKEN_INT64  */
#line 958 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt64->GetAsUnboundVariabilityType(); }
#line 3928 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 163: /* atomic_var_type_specifier: TOKEN_UINT64  */
#line 959 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt64->GetAsUnboundVariabilityType(); }
#line 3934 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 164: /* short_vec_specifier: atomic_var_type_specifier '<' int_constant '>'  */
#line 964 "src/parse.yy"
    {
        (yyval.type) = (yyvsp[-3].atomicType) ? new VectorType((yyvsp[-3].atomicType), (int32_t)(yyvsp[-1].intVal)) : NULL;
    }
#line 3942 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 165: /* struct_or_union_name: TOKEN_IDENTIFIER  */
#line 970 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 3948 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 166: /* struct_or_union_name: TOKEN_TYPE_NAME  */
#line 971 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 3954 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 167: /* struct_or_union_and_name: struct_or_union struct_or_union_name  */
#line 976 "src/parse.yy"
      {
          const Type *st = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (st == NULL) {
              st = new UndefinedStructType((yyvsp[0].constCharPtr), Variability::Unbound, false, (yylsp[0]));
              m->symbolTable->AddType((yyvsp[0].constCharPtr), st, (yylsp[0]));
              (yyval.type) = st;
          }
          else {
              if (CastType<StructType>(st) == NULL &&
                  CastType<UndefinedStructType>(st) == NULL) {
                  Error((yylsp[0]), "Type \"%s\" is not a struct type! (%s)", (yyvsp[0].constCharPtr),
                        st->GetString().c_str());
                  (yyval.type) = NULL;
              }
              else
                  (yyval.type) = st;
         }
      }
#line 3977 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 169: /* struct_or_union_specifier: struct_or_union_and_name '{' struct_declaration_list '}'  */
#line 999 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != NULL) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              const std::string &name = CastType<StructType>((yyvsp[-3].type)) ?
                  CastType<StructType>((yyvsp[-3].type))->GetStructName() :
                  CastType<UndefinedStructType>((yyvsp[-3].type))->GetStructName();
              StructType *st = new StructType(name, elementTypes, elementNames,
                                              elementPositions, false, Variability::Unbound, (yylsp[-3]));
              m->symbolTable->AddType(name.c_str(), st, (yylsp[-3]));
              (yyval.type) = st;
          }
          else
              (yyval.type) = NULL;
      }
#line 4000 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 170: /* struct_or_union_specifier: struct_or_union '{' struct_declaration_list '}'  */
#line 1018 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != NULL) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                                  false, Variability::Unbound, (yylsp[-3]));
          }
          else
              (yyval.type) = NULL;
      }
#line 4018 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 171: /* struct_or_union_specifier: struct_or_union '{' '}'  */
#line 1032 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                              false, Variability::Unbound, (yylsp[-2]));
      }
#line 4030 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 172: /* struct_or_union_specifier: struct_or_union_and_name '{' '}'  */
#line 1040 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          const std::string &name = CastType<StructType>((yyvsp[-2].type)) ?
              CastType<StructType>((yyvsp[-2].type))->GetStructName() :
              CastType<UndefinedStructType>((yyvsp[-2].type))->GetStructName();
          StructType *st = new StructType(name, elementTypes,
                                          elementNames, elementPositions,
                                          false, Variability::Unbound, (yylsp[-2]));
          m->symbolTable->AddType(name.c_str(), st, (yylsp[-1]));
          (yyval.type) = st;
      }
#line 4048 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 174: /* struct_declaration_list: struct_declaration  */
#line 1061 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = new std::vector<StructDeclaration *>;
          if ((yyvsp[0].structDeclaration) != NULL)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4059 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 175: /* struct_declaration_list: struct_declaration_list struct_declaration  */
#line 1068 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = (std::vector<StructDeclaration *> *)(yyvsp[-1].structDeclarationList);
          if (sdl == NULL) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sdl = new std::vector<StructDeclaration *>;
          }
          if ((yyvsp[0].structDeclaration) != NULL)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4074 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 176: /* struct_declaration: specifier_qualifier_list struct_declarator_list ';'  */
#line 1082 "src/parse.yy"
      { (yyval.structDeclaration) = ((yyvsp[-2].type) != NULL && (yyvsp[-1].structDeclaratorList) != NULL) ? new StructDeclaration((yyvsp[-2].type), (yyvsp[-1].structDeclaratorList)) : NULL; }
#line 4080 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 180: /* specifier_qualifier_list: type_qualifier specifier_qualifier_list  */
#line 1090 "src/parse.yy"
    {
        if ((yyvsp[0].type) != NULL) {
            if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNIFORM) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = NULL;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VARYING) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = NULL;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_CONST)
                (yyval.type) = (yyvsp[0].type)->GetAsConstType();
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_SIGNED) {
                if ((yyvsp[0].type)->IsIntType() == false) {
                    Error((yylsp[-1]), "Can't apply \"signed\" qualifier to \"%s\" type.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNSIGNED) {
                const Type *t = (yyvsp[0].type)->GetAsUnsignedType();
                if (t)
                    (yyval.type) = t;
                else {
                    Error((yylsp[-1]), "Can't apply \"unsigned\" qualifier to \"%s\" type. Ignoring.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_INLINE) {
                Error((yylsp[-1]), "\"inline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_NOINLINE) {
                Error((yylsp[-1]), "\"noinline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VECTORCALL) {
                Error((yylsp[-1]), "\"__vectorcall\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_TASK) {
                Error((yylsp[-1]), "\"task\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNMASKED) {
                Error((yylsp[-1]), "\"unmasked\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_EXPORT) {
                Error((yylsp[-1]), "\"export\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else
                FATAL("Unhandled type qualifier in parser.");
        }
        else {
            if (m->errorCount == 0)
                Error((yylsp[-1]), "Lost type qualifier in parser.");
            (yyval.type) = NULL;
        }
    }
#line 4161 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 181: /* struct_declarator_list: struct_declarator  */
#line 1171 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != NULL)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4172 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 182: /* struct_declarator_list: struct_declarator_list ',' struct_declarator  */
#line 1178 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = (std::vector<Declarator *> *)(yyvsp[-2].structDeclaratorList);
          if (sdl == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              sdl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != NULL)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4187 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 183: /* struct_declarator: declarator  */
#line 1191 "src/parse.yy"
                 { (yyval.declarator) = (yyvsp[0].declarator); }
#line 4193 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 184: /* enum_identifier: TOKEN_IDENTIFIER  */
#line 1199 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 4199 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 185: /* enum_specifier: TOKEN_ENUM '{' enumerator_list '}'  */
#line 1203 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(NULL, (yyvsp[-1].symbolList), (yylsp[-3]));
      }
#line 4207 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 186: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list '}'  */
#line 1207 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-3].constCharPtr), (yyvsp[-1].symbolList), (yylsp[-3]));
      }
#line 4215 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 187: /* enum_specifier: TOKEN_ENUM '{' enumerator_list ',' '}'  */
#line 1211 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(NULL, (yyvsp[-2].symbolList), (yylsp[-4]));
      }
#line 4223 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 188: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list ',' '}'  */
#line 1215 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-4].constCharPtr), (yyvsp[-2].symbolList), (yylsp[-4]));
      }
#line 4231 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 189: /* enum_specifier: TOKEN_ENUM enum_identifier  */
#line 1219 "src/parse.yy"
      {
          const Type *type = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (type == NULL) {
              std::vector<std::string> alternates = m->symbolTable->ClosestEnumTypeMatch((yyvsp[0].constCharPtr));
              std::string alts = lGetAlternates(alternates);
              Error((yylsp[0]), "Enum type \"%s\" unknown.%s", (yyvsp[0].constCharPtr), alts.c_str());
              (yyval.enumType) = NULL;
          }
          else {
              const EnumType *enumType = CastType<EnumType>(type);
              if (enumType == NULL) {
                  Error((yylsp[0]), "Type \"%s\" is not an enum type (%s).", (yyvsp[0].constCharPtr),
                        type->GetString().c_str());
                  (yyval.enumType) = NULL;
              }
              else
                  (yyval.enumType) = enumType;
          }
      }
#line 4255 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 190: /* enumerator_list: enumerator  */
#line 1242 "src/parse.yy"
      {
          if ((yyvsp[0].symbol) == NULL)
              (yyval.symbolList) = NULL;
          else {
              std::vector<Symbol *> *el = new std::vector<Symbol *>;
              el->push_back((yyvsp[0].symbol));
              (yyval.symbolList) = el;
          }
      }
#line 4269 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 191: /* enumerator_list: enumerator_list ',' enumerator  */
#line 1252 "src/parse.yy"
      {
          std::vector<Symbol *> *symList = (yyvsp[-2].symbolList);
          if (symList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              symList = new std::vector<Symbol *>;
          }
          if ((yyvsp[0].symbol) != NULL)
              symList->push_back((yyvsp[0].symbol));
          (yyval.symbolList) = symList;
      }
#line 4284 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 192: /* enumerator: enum_identifier  */
#line 1266 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol((yyvsp[0].constCharPtr), (yylsp[0]));
      }
#line 4292 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 193: /* enumerator: enum_identifier '=' constant_expression  */
#line 1270 "src/parse.yy"
      {
          int value;
          if ((yyvsp[-2].constCharPtr) != NULL && (yyvsp[0].expr) != NULL &&
              lGetConstantInt((yyvsp[0].expr), &value, (yylsp[0]), "Enumerator value")) {
              Symbol *sym = new Symbol((yyvsp[-2].constCharPtr), (yylsp[-2]));
              sym->constValue = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                                              (uint32_t)value, (yylsp[0]));
              (yyval.symbol) = sym;
          }
          else
              (yyval.symbol) = NULL;
      }
#line 4309 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 194: /* type_qualifier: TOKEN_CONST  */
#line 1285 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_CONST; }
#line 4315 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 195: /* type_qualifier: TOKEN_UNIFORM  */
#line 1286 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNIFORM; }
#line 4321 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 196: /* type_qualifier: TOKEN_VARYING  */
#line 1287 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_VARYING; }
#line 4327 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 197: /* type_qualifier: TOKEN_TASK  */
#line 1288 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_TASK; }
#line 4333 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 198: /* type_qualifier: TOKEN_UNMASKED  */
#line 1289 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNMASKED; }
#line 4339 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 199: /* type_qualifier: TOKEN_EXPORT  */
#line 1290 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_EXPORT; }
#line 4345 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 200: /* type_qualifier: TOKEN_INLINE  */
#line 1291 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_INLINE; }
#line 4351 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 201: /* type_qualifier: TOKEN_NOINLINE  */
#line 1292 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_NOINLINE; }
#line 4357 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 202: /* type_qualifier: TOKEN_VECTORCALL  */
#line 1293 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_VECTORCALL; }
#line 4363 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 203: /* type_qualifier: TOKEN_SIGNED  */
#line 1294 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_SIGNED; }
#line 4369 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 204: /* type_qualifier: TOKEN_UNSIGNED  */
#line 1295 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNSIGNED; }
#line 4375 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 205: /* type_qualifier_list: type_qualifier  */
#line 1300 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[0].typeQualifier);
    }
#line 4383 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 206: /* type_qualifier_list: type_qualifier_list type_qualifier  */
#line 1304 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[-1].typeQualifier) | (yyvsp[0].typeQualifier);
    }
#line 4391 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 207: /* declarator: pointer direct_declarator  */
#line 1311 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != NULL) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != NULL)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4407 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 208: /* declarator: reference direct_declarator  */
#line 1323 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != NULL) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != NULL)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4423 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 210: /* int_constant: TOKEN_INT8_CONSTANT  */
#line 1338 "src/parse.yy"
                          { (yyval.intVal) = yylval.intVal; }
#line 4429 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 211: /* int_constant: TOKEN_INT16_CONSTANT  */
#line 1339 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4435 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 212: /* int_constant: TOKEN_INT32_CONSTANT  */
#line 1340 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4441 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 213: /* int_constant: TOKEN_INT64_CONSTANT  */
#line 1341 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4447 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 214: /* direct_declarator: TOKEN_IDENTIFIER  */
#line 1346 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
      }
#line 4457 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 215: /* direct_declarator: '(' declarator ')'  */
#line 1352 "src/parse.yy"
    {
        (yyval.declarator) = (yyvsp[-1].declarator);
    }
#line 4465 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 216: /* direct_declarator: direct_declarator '[' constant_expression ']'  */
#line 1356 "src/parse.yy"
    {
        int size;
        if ((yyvsp[-3].declarator) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            if (size < 0) {
                Error((yylsp[-1]), "Array dimension must be non-negative.");
                (yyval.declarator) = NULL;
            }
            else {
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                d->arraySize = size;
                d->child = (yyvsp[-3].declarator);
                (yyval.declarator) = d;
            }
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4487 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 217: /* direct_declarator: direct_declarator '[' ']'  */
#line 1374 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != NULL) {
            Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
            d->arraySize = 0; // unsize
            d->child = (yyvsp[-2].declarator);
            (yyval.declarator) = d;
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4502 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 218: /* direct_declarator: direct_declarator '[' error ']'  */
#line 1385 "src/parse.yy"
    {
         (yyval.declarator) = NULL;
    }
#line 4510 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 219: /* direct_declarator: direct_declarator '(' parameter_type_list ')'  */
#line 1389 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) != NULL) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != NULL)
                  d->functionParams = *(yyvsp[-1].declarationList);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4526 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 220: /* direct_declarator: direct_declarator '(' ')'  */
#line 1401 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != NULL) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4540 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 221: /* direct_declarator: direct_declarator '(' error ')'  */
#line 1411 "src/parse.yy"
    {
        (yyval.declarator) = NULL;
    }
#line 4548 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 222: /* pointer: '*'  */
#line 1419 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_POINTER, (yylsp[0]));
    }
#line 4556 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 223: /* pointer: '*' type_qualifier_list  */
#line 1423 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[0].typeQualifier);
          (yyval.declarator) = d;
      }
#line 4566 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 224: /* pointer: '*' pointer  */
#line 1429 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 4576 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 225: /* pointer: '*' type_qualifier_list pointer  */
#line 1435 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-2]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[-1].typeQualifier);
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 4587 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 226: /* reference: '&'  */
#line 1446 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
    }
#line 4595 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 227: /* parameter_type_list: parameter_list  */
#line 1453 "src/parse.yy"
                     { (yyval.declarationList) = (yyvsp[0].declarationList); }
#line 4601 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 228: /* parameter_list: parameter_declaration  */
#line 1458 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != NULL)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 4612 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 229: /* parameter_list: parameter_list ',' parameter_declaration  */
#line 1465 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = (std::vector<Declaration *> *)(yyvsp[-2].declarationList);
        if (dl == NULL)
            dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != NULL)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 4625 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 230: /* parameter_list: error ','  */
#line 1474 "src/parse.yy"
    {
        lSuggestParamListAlternates();
        (yyval.declarationList) = NULL;
    }
#line 4634 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 231: /* parameter_declaration: declaration_specifiers declarator  */
#line 1482 "src/parse.yy"
    {
        (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
    }
#line 4642 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 232: /* parameter_declaration: declaration_specifiers declarator '=' initializer  */
#line 1486 "src/parse.yy"
    {
        if ((yyvsp[-3].declSpecs) != NULL && (yyvsp[-2].declarator) != NULL) {
            (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
            (yyval.declaration) = new Declaration((yyvsp[-3].declSpecs), (yyvsp[-2].declarator));
        }
        else
            (yyval.declaration) = NULL;
    }
#line 4655 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 233: /* parameter_declaration: declaration_specifiers abstract_declarator  */
#line 1495 "src/parse.yy"
    {
        if ((yyvsp[-1].declSpecs) != NULL && (yyvsp[0].declarator) != NULL)
            (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        else
            (yyval.declaration) = NULL;
    }
#line 4666 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 234: /* parameter_declaration: declaration_specifiers  */
#line 1502 "src/parse.yy"
    {
        if ((yyvsp[0].declSpecs) == NULL)
            (yyval.declaration) = NULL;
        else
            (yyval.declaration) = new Declaration((yyvsp[0].declSpecs));
    }
#line 4677 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 236: /* type_name: specifier_qualifier_list abstract_declarator  */
#line 1520 "src/parse.yy"
    {
        if ((yyvsp[-1].type) == NULL || (yyvsp[0].declarator) == NULL)
            (yyval.type) = NULL;
        else {
            (yyvsp[0].declarator)->InitFromType((yyvsp[-1].type), NULL);
            (yyval.type) = (yyvsp[0].declarator)->type;
        }
    }
#line 4690 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 237: /* abstract_declarator: pointer  */
#line 1532 "src/parse.yy"
      {
          (yyval.declarator) = (yyvsp[0].declarator);
      }
#line 4698 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 239: /* abstract_declarator: pointer direct_abstract_declarator  */
#line 1537 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4712 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 240: /* abstract_declarator: reference  */
#line 1547 "src/parse.yy"
      {
          (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
      }
#line 4720 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 241: /* abstract_declarator: reference direct_abstract_declarator  */
#line 1551 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_REFERENCE, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4734 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 242: /* direct_abstract_declarator: '(' abstract_declarator ')'  */
#line 1564 "src/parse.yy"
      { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 4740 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 243: /* direct_abstract_declarator: '[' ']'  */
#line 1566 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-1]), (yylsp[0])));
          d->arraySize = 0;
          (yyval.declarator) = d;
      }
#line 4750 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 244: /* direct_abstract_declarator: '[' constant_expression ']'  */
#line 1572 "src/parse.yy"
      {
        int size;
        if ((yyvsp[-1].expr) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            if (size < 0) {
                Error((yylsp[-1]), "Array dimension must be non-negative.");
                (yyval.declarator) = NULL;
            }
            else {
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
                d->arraySize = size;
                (yyval.declarator) = d;
            }
        }
        else
            (yyval.declarator) = NULL;
      }
#line 4771 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 245: /* direct_abstract_declarator: direct_abstract_declarator '[' ']'  */
#line 1589 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
              d->arraySize = 0;
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4786 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 246: /* direct_abstract_declarator: direct_abstract_declarator '[' constant_expression ']'  */
#line 1600 "src/parse.yy"
      {
          int size;
          if ((yyvsp[-3].declarator) != NULL && (yyvsp[-1].expr) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
              if (size < 0) {
                  Error((yylsp[-1]), "Array dimension must be non-negative.");
                  (yyval.declarator) = NULL;
              }
              else {
                  Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                  d->arraySize = size;
                  d->child = (yyvsp[-3].declarator);
                  (yyval.declarator) = d;
              }
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4808 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 247: /* direct_abstract_declarator: '(' ')'  */
#line 1618 "src/parse.yy"
      { (yyval.declarator) = new Declarator(DK_FUNCTION, Union((yylsp[-1]), (yylsp[0]))); }
#line 4814 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 248: /* direct_abstract_declarator: '(' parameter_type_list ')'  */
#line 1620 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
          if ((yyvsp[-1].declarationList) != NULL) d->functionParams = *(yyvsp[-1].declarationList);
          (yyval.declarator) = d;
      }
#line 4824 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 249: /* direct_abstract_declarator: direct_abstract_declarator '(' ')'  */
#line 1626 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4838 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 250: /* direct_abstract_declarator: direct_abstract_declarator '(' parameter_type_list ')'  */
#line 1636 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != NULL) d->functionParams = *(yyvsp[-1].declarationList);
              (yyval.declarator) = d;
          }
      }
#line 4853 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 252: /* initializer: '{' initializer_list '}'  */
#line 1650 "src/parse.yy"
                               { (yyval.expr) = (yyvsp[-1].exprList); }
#line 4859 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 253: /* initializer: '{' initializer_list ',' '}'  */
#line 1651 "src/parse.yy"
                                   { (yyval.expr) = (yyvsp[-2].exprList); }
#line 4865 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 254: /* initializer_list: initializer  */
#line 1656 "src/parse.yy"
      { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 4871 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 255: /* initializer_list: initializer_list ',' initializer  */
#line 1658 "src/parse.yy"
      {
          ExprList *exprList = (yyvsp[-2].exprList);
          if (exprList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              exprList = new ExprList((yylsp[0]));
          }
          exprList->exprs.push_back((yyvsp[0].expr));
          exprList->pos = Union(exprList->pos, (yylsp[0]));
          (yyval.exprList) = exprList;
      }
#line 4886 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 268: /* statement: error ';'  */
#line 1684 "src/parse.yy"
    {
        lSuggestBuiltinAlternates();
        (yyval.stmt) = NULL;
    }
#line 4895 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 269: /* labeled_statement: goto_identifier ':' statement  */
#line 1692 "src/parse.yy"
    {
        (yyval.stmt) = new LabeledStmt((yyvsp[-2].constCharPtr), (yyvsp[0].stmt), (yylsp[-2]));
    }
#line 4903 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 270: /* labeled_statement: TOKEN_CASE constant_expression ':' statement  */
#line 1696 "src/parse.yy"
      {
          int value;
          if ((yyvsp[-2].expr) != NULL &&
              lGetConstantInt((yyvsp[-2].expr), &value, (yylsp[-2]), "Case statement value")) {
              (yyval.stmt) = new CaseStmt(value, (yyvsp[0].stmt), Union((yylsp[-3]), (yylsp[-2])));
          }
          else
              (yyval.stmt) = NULL;
      }
#line 4917 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 271: /* labeled_statement: TOKEN_DEFAULT ':' statement  */
#line 1706 "src/parse.yy"
      { (yyval.stmt) = new DefaultStmt((yyvsp[0].stmt), (yylsp[-2])); }
#line 4923 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 272: /* start_scope: '{'  */
#line 1710 "src/parse.yy"
          { m->symbolTable->PushScope(); }
#line 4929 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 273: /* end_scope: '}'  */
#line 1714 "src/parse.yy"
          { m->symbolTable->PopScope(); }
#line 4935 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 274: /* compound_statement: '{' '}'  */
#line 1718 "src/parse.yy"
              { (yyval.stmt) = NULL; }
#line 4941 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 275: /* compound_statement: start_scope statement_list end_scope  */
#line 1719 "src/parse.yy"
                                           { (yyval.stmt) = (yyvsp[-1].stmt); }
#line 4947 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 276: /* statement_list: statement  */
#line 1724 "src/parse.yy"
      {
          StmtList *sl = new StmtList((yylsp[0]));
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 4957 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 277: /* statement_list: statement_list statement  */
#line 1730 "src/parse.yy"
      {
          StmtList *sl = (StmtList *)(yyvsp[-1].stmt);
          if (sl == NULL) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sl = new StmtList((yylsp[0]));
          }
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 4971 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 278: /* expression_statement: ';'  */
#line 1742 "src/parse.yy"
          { (yyval.stmt) = NULL; }
#line 4977 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 279: /* expression_statement: expression ';'  */
#line 1743 "src/parse.yy"
                     { (yyval.stmt) = (yyvsp[-1].expr) ? new ExprStmt((yyvsp[-1].expr), (yylsp[-1])) : NULL; }
#line 4983 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 280: /* selection_statement: TOKEN_IF '(' expression ')' statement  */
#line 1748 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), NULL, false, (yylsp[-4])); }
#line 4989 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 281: /* selection_statement: TOKEN_IF '(' expression ')' statement TOKEN_ELSE statement  */
#line 1750 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), false, (yylsp[-6])); }
#line 4995 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 282: /* selection_statement: TOKEN_CIF '(' expression ')' statement  */
#line 1752 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), NULL, true, (yylsp[-4])); }
#line 5001 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 283: /* selection_statement: TOKEN_CIF '(' expression ')' statement TOKEN_ELSE statement  */
#line 1754 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), true, (yylsp[-6])); }
#line 5007 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 284: /* selection_statement: TOKEN_SWITCH '(' expression ')' statement  */
#line 1756 "src/parse.yy"
      { (yyval.stmt) = new SwitchStmt((yyvsp[-2].expr), (yyvsp[0].stmt), (yylsp[-4])); }
#line 5013 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 285: /* for_test: ';'  */
#line 1761 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 5019 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 286: /* for_test: expression ';'  */
#line 1763 "src/parse.yy"
      { (yyval.expr) = (yyvsp[-1].expr); }
#line 5025 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 289: /* for_scope: TOKEN_FOR  */
#line 1772 "src/parse.yy"
                { m->symbolTable->PushScope(); }
#line 5031 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 290: /* cfor_scope: TOKEN_CFOR  */
#line 1776 "src/parse.yy"
                 { m->symbolTable->PushScope(); }
#line 5037 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 291: /* foreach_scope: TOKEN_FOREACH  */
#line 1780 "src/parse.yy"
                    { m->symbolTable->PushScope(); }
#line 5043 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 292: /* foreach_tiled_scope: TOKEN_FOREACH_TILED  */
#line 1784 "src/parse.yy"
                          { m->symbolTable->PushScope(); }
#line 5049 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 293: /* foreach_identifier: TOKEN_IDENTIFIER  */
#line 1789 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), AtomicType::VaryingInt32->GetAsConstType());
    }
#line 5057 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 294: /* foreach_active_scope: TOKEN_FOREACH_ACTIVE  */
#line 1795 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 5063 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 295: /* foreach_active_identifier: TOKEN_IDENTIFIER  */
#line 1800 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), AtomicType::UniformInt64->GetAsConstType());
    }
#line 5071 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 296: /* integer_dotdotdot: TOKEN_INT32DOTDOTDOT_CONSTANT  */
#line 1806 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 5080 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 297: /* integer_dotdotdot: TOKEN_UINT32DOTDOTDOT_CONSTANT  */
#line 1810 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 5089 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 298: /* integer_dotdotdot: TOKEN_INT64DOTDOTDOT_CONSTANT  */
#line 1814 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 5098 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 299: /* integer_dotdotdot: TOKEN_UINT64DOTDOTDOT_CONSTANT  */
#line 1818 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 5107 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 300: /* foreach_dimension_specifier: foreach_identifier '=' assignment_expression TOKEN_DOTDOTDOT assignment_expression  */
#line 1826 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-4].symbol), (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 5115 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 301: /* foreach_dimension_specifier: foreach_identifier '=' integer_dotdotdot assignment_expression  */
#line 1830 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-3].symbol), (yyvsp[-1].expr), (yyvsp[0].expr));
    }
#line 5123 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 302: /* foreach_dimension_list: foreach_dimension_specifier  */
#line 1837 "src/parse.yy"
    {
        (yyval.foreachDimensionList) = new std::vector<ForeachDimension *>;
        (yyval.foreachDimensionList)->push_back((yyvsp[0].foreachDimension));
    }
#line 5132 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 303: /* foreach_dimension_list: foreach_dimension_list ',' foreach_dimension_specifier  */
#line 1842 "src/parse.yy"
    {
        std::vector<ForeachDimension *> *dv = (yyvsp[-2].foreachDimensionList);
        if (dv == NULL) {
            AssertPos((yylsp[-2]), m->errorCount > 0);
            dv = new std::vector<ForeachDimension *>;
        }
        if ((yyvsp[0].foreachDimension) != NULL)
            dv->push_back((yyvsp[0].foreachDimension));
        (yyval.foreachDimensionList) = dv;
    }
#line 5147 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 304: /* foreach_unique_scope: TOKEN_FOREACH_UNIQUE  */
#line 1855 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 5153 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 305: /* foreach_unique_identifier: TOKEN_IDENTIFIER  */
#line 1859 "src/parse.yy"
                       { (yyval.constCharPtr) = yylval.stringVal->c_str(); }
#line 5159 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 306: /* iteration_statement: TOKEN_WHILE '(' expression ')' statement  */
#line 1864 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(NULL, (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), false, (yylsp[-4])); }
#line 5165 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 307: /* iteration_statement: TOKEN_CWHILE '(' expression ')' statement  */
#line 1866 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(NULL, (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), true, (yylsp[-4])); }
#line 5171 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 308: /* iteration_statement: TOKEN_DO statement TOKEN_WHILE '(' expression ')' ';'  */
#line 1868 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), false, (yylsp[-6])); }
#line 5177 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 309: /* iteration_statement: TOKEN_CDO statement TOKEN_WHILE '(' expression ')' ';'  */
#line 1870 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), true, (yylsp[-6])); }
#line 5183 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 310: /* iteration_statement: for_scope '(' for_init_statement for_test ')' statement  */
#line 1872 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), false, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 5191 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 311: /* iteration_statement: for_scope '(' for_init_statement for_test expression ')' statement  */
#line 1876 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), false, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 5199 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 312: /* iteration_statement: cfor_scope '(' for_init_statement for_test ')' statement  */
#line 1880 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), true, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 5207 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 313: /* iteration_statement: cfor_scope '(' for_init_statement for_test expression ')' statement  */
#line 1884 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), true, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 5215 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 314: /* $@1: %empty  */
#line 1888 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }
         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 5229 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 315: /* iteration_statement: foreach_scope '(' foreach_dimension_list ')' $@1 statement  */
#line 1898 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-3]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), false, (yylsp[-5]));
         m->symbolTable->PopScope();
     }
#line 5251 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 316: /* $@2: %empty  */
#line 1916 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 5266 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 317: /* iteration_statement: foreach_tiled_scope '(' foreach_dimension_list ')' $@2 statement  */
#line 1927 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-5]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), true, (yylsp[-5]));
         m->symbolTable->PopScope();
     }
#line 5288 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 318: /* $@3: %empty  */
#line 1945 "src/parse.yy"
     {
         if ((yyvsp[-1].symbol) != NULL)
             m->symbolTable->AddVariable((yyvsp[-1].symbol));
     }
#line 5297 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 319: /* iteration_statement: foreach_active_scope '(' foreach_active_identifier ')' $@3 statement  */
#line 1950 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachActiveStmt((yyvsp[-3].symbol), (yyvsp[0].stmt), Union((yylsp[-5]), (yylsp[-2])));
         m->symbolTable->PopScope();
     }
#line 5306 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 320: /* $@4: %empty  */
#line 1956 "src/parse.yy"
     {
         Expr *expr = (yyvsp[-1].expr);
         const Type *type;
         if (expr != NULL &&
             (expr = TypeCheck(expr)) != NULL &&
             (type = expr->GetType()) != NULL) {
             const Type *iterType = type->GetAsUniformType()->GetAsConstType();
             Symbol *sym = new Symbol((yyvsp[-3].constCharPtr), (yylsp[-3]), iterType);
             m->symbolTable->AddVariable(sym);
         }
     }
#line 5322 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 321: /* iteration_statement: foreach_unique_scope '(' foreach_unique_identifier TOKEN_IN expression ')' $@4 statement  */
#line 1968 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachUniqueStmt((yyvsp[-5].constCharPtr), (yyvsp[-3].expr), (yyvsp[0].stmt), (yylsp[-7]));
         m->symbolTable->PopScope();
     }
#line 5331 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 322: /* goto_identifier: TOKEN_IDENTIFIER  */
#line 1975 "src/parse.yy"
                       { (yyval.constCharPtr) = yylval.stringVal->c_str(); }
#line 5337 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 323: /* jump_statement: TOKEN_GOTO goto_identifier ';'  */
#line 1980 "src/parse.yy"
      { (yyval.stmt) = new GotoStmt((yyvsp[-1].constCharPtr), (yylsp[-2]), (yylsp[-1])); }
#line 5343 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 324: /* jump_statement: TOKEN_CONTINUE ';'  */
#line 1982 "src/parse.yy"
      { (yyval.stmt) = new ContinueStmt((yylsp[-1])); }
#line 5349 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 325: /* jump_statement: TOKEN_BREAK ';'  */
#line 1984 "src/parse.yy"
      { (yyval.stmt) = new BreakStmt((yylsp[-1])); }
#line 5355 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 326: /* jump_statement: TOKEN_RETURN ';'  */
#line 1986 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt(NULL, (yylsp[-1])); }
#line 5361 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 327: /* jump_statement: TOKEN_RETURN expression ';'  */
#line 1988 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt((yyvsp[-1].expr), (yylsp[-2])); }
#line 5367 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 328: /* sync_statement: TOKEN_SYNC ';'  */
#line 1993 "src/parse.yy"
      { (yyval.stmt) = new ExprStmt(new SyncExpr((yylsp[-1])), (yylsp[-1])); }
#line 5373 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 329: /* delete_statement: TOKEN_DELETE expression ';'  */
#line 1998 "src/parse.yy"
    {
        (yyval.stmt) = new DeleteStmt((yyvsp[-1].expr), Union((yylsp[-2]), (yylsp[-1])));
    }
#line 5381 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 330: /* unmasked_statement: TOKEN_UNMASKED '{' statement_list '}'  */
#line 2005 "src/parse.yy"
    {
        (yyval.stmt) = new UnmaskedStmt((yyvsp[-1].stmt), (yylsp[-3]));
    }
#line 5389 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 331: /* print_statement: TOKEN_PRINT '(' string_constant ')' ';'  */
#line 2012 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-2].stringVal), NULL, (yylsp[-4]));
      }
#line 5397 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 332: /* print_statement: TOKEN_PRINT '(' string_constant ',' argument_expression_list ')' ';'  */
#line 2016 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].exprList), (yylsp[-6]));
      }
#line 5405 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 333: /* assert_statement: TOKEN_ASSERT '(' string_constant ',' expression ')' ';'  */
#line 2023 "src/parse.yy"
      {
          (yyval.stmt) = new AssertStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].expr), (yylsp[-6]));
      }
#line 5413 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 339: /* external_declaration: TOKEN_EXPORT '{' type_specifier_list '}' ';'  */
#line 2038 "src/parse.yy"
    {
        if ((yyvsp[-2].typeList) != NULL)
            m->AddExportedTypes(*(yyvsp[-2].typeList));
    }
#line 5422 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 340: /* external_declaration: declaration  */
#line 2043 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) != NULL)
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i)
                lAddDeclaration((yyvsp[0].declaration)->declSpecs, (yyvsp[0].declaration)->declarators[i]);
    }
#line 5432 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 342: /* $@5: %empty  */
#line 2053 "src/parse.yy"
    {
        lAddDeclaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        lAddFunctionParams((yyvsp[0].declarator));
        lAddMaskToSymbolTable((yylsp[0]));
        if ((yyvsp[-1].declSpecs)->typeQualifiers & TYPEQUAL_TASK)
            lAddThreadIndexCountToSymbolTable((yylsp[0]));
    }
#line 5444 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;

  case 343: /* function_definition: declaration_specifiers declarator $@5 compound_statement  */
#line 2061 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != NULL) {
            (yyvsp[-2].declarator)->InitFromDeclSpecs((yyvsp[-3].declSpecs));
            const FunctionType *funcType = CastType<FunctionType>((yyvsp[-2].declarator)->type);
            if (funcType == NULL)
                AssertPos((yylsp[-3]), m->errorCount > 0);
            else if ((yyvsp[-3].declSpecs)->storageClass == SC_TYPEDEF)
                Error((yylsp[-3]), "Illegal \"typedef\" provided with function definition.");
            else {
                Stmt *code = (yyvsp[0].stmt);
                if (code == NULL) code = new StmtList((yylsp[0]));
                m->AddFunctionDefinition((yyvsp[-2].declarator)->name, funcType, code);
            }
        }
        m->symbolTable->PopScope(); // push in lAddFunctionParams();
    }
#line 5465 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"
    break;


#line 5469 "/home/iurt/rpmbuild/BUILD/ispc-1.14.1/build/./parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2087 "src/parse.yy"



void yyerror(const char *s) {
    if (strlen(yytext) == 0)
        Error(yylloc, "Premature end of file: %s.", s);
    else
        Error(yylloc, "%s.", s);
}


static int
lYYTNameErr (char *yyres, const char *yystr)
{
  extern std::map<std::string, std::string> tokenNameRemap;
  Assert(tokenNameRemap.size() > 0);
  if (tokenNameRemap.find(yystr) != tokenNameRemap.end()) {
      std::string n = tokenNameRemap[yystr];
      if (yyres == NULL)
          return n.size();
      else
          return yystpcpy(yyres, n.c_str()) - yyres;
  }

  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}

static void
lSuggestBuiltinAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lBuiltinTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
         Error(yylloc, "%s", alts.c_str());
}


static void
lSuggestParamListAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lParamListTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
        Error(yylloc, "%s", alts.c_str());
}


static void
lAddDeclaration(DeclSpecs *ds, Declarator *decl) {
    if (ds == NULL || decl == NULL)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    if (ds->storageClass == SC_TYPEDEF)
        m->AddTypeDef(decl->name, decl->type, decl->pos);
    else {
        if (decl->type == NULL) {
            Assert(m->errorCount > 0);
            return;
        }

        decl->type = decl->type->ResolveUnboundVariability(Variability::Varying);

        const FunctionType *ft = CastType<FunctionType>(decl->type);
        if (ft != NULL) {
            bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
            bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
            bool isVectorCall = (ds->typeQualifiers & TYPEQUAL_VECTORCALL);
            m->AddFunctionDeclaration(decl->name, ft, ds->storageClass,
                                      isInline, isNoInline, isVectorCall, decl->pos);
        }
        else {
            bool isConst = (ds->typeQualifiers & TYPEQUAL_CONST) != 0;
            m->AddGlobalVariable(decl->name, decl->type, decl->initExpr,
                                 isConst, decl->storageClass, decl->pos);
        }
    }
}


/** We're about to start parsing the body of a function; add all of the
    parameters to the symbol table so that they're available.
*/
static void
lAddFunctionParams(Declarator *decl) {
    m->symbolTable->PushScope();

    if (decl == NULL) {
        return;
    }

    // walk down to the declarator for the function itself
    while (decl->kind != DK_FUNCTION && decl->child != NULL)
        decl = decl->child;
    if (decl->kind != DK_FUNCTION) {
        AssertPos(decl->pos, m->errorCount > 0);
        return;
    }

    // now loop over its parameters and add them to the symbol table
    for (unsigned int i = 0; i < decl->functionParams.size(); ++i) {
        Declaration *pdecl = decl->functionParams[i];
        Assert(pdecl != NULL && pdecl->declarators.size() == 1);
        Declarator *declarator = pdecl->declarators[0];
        if (declarator == NULL)
            AssertPos(decl->pos, m->errorCount > 0);
        else {
            Symbol *sym = new Symbol(declarator->name, declarator->pos,
                                     declarator->type, declarator->storageClass);
#ifndef NDEBUG
            bool ok = m->symbolTable->AddVariable(sym);
            if (ok == false)
                AssertPos(decl->pos, m->errorCount > 0);
#else
            m->symbolTable->AddVariable(sym);
#endif
        }
    }

    // The corresponding pop scope happens in function_definition rules
    // above...
}


/** Add a symbol for the built-in mask variable to the symbol table */
static void lAddMaskToSymbolTable(SourcePos pos) {
    const Type *t = NULL;
    switch (g->target->getMaskBitCount()) {
    case 1:
        t = AtomicType::VaryingBool;
        break;
    case 8:
        t = AtomicType::VaryingUInt8;
        break;
    case 16:
        t = AtomicType::VaryingUInt16;
        break;
    case 32:
        t = AtomicType::VaryingUInt32;
        break;
    case 64:
        t = AtomicType::VaryingUInt64;
        break;
    default:
        FATAL("Unhandled mask bitsize in lAddMaskToSymbolTable");
    }

    t = t->GetAsConstType();
    Symbol *maskSymbol = new Symbol("__mask", pos, t);
    m->symbolTable->AddVariable(maskSymbol);
}


/** Add the thread index and thread count variables to the symbol table
    (this should only be done for 'task'-qualified functions. */
static void lAddThreadIndexCountToSymbolTable(SourcePos pos) {
    const Type *type = AtomicType::UniformUInt32->GetAsConstType();

    Symbol *threadIndexSym = new Symbol("threadIndex", pos, type);
    m->symbolTable->AddVariable(threadIndexSym);

    Symbol *threadCountSym = new Symbol("threadCount", pos, type);
    m->symbolTable->AddVariable(threadCountSym);

    Symbol *taskIndexSym = new Symbol("taskIndex", pos, type);
    m->symbolTable->AddVariable(taskIndexSym);
    
    Symbol *taskCountSym = new Symbol("taskCount", pos, type);
    m->symbolTable->AddVariable(taskCountSym);
    
    Symbol *taskIndexSym0 = new Symbol("taskIndex0", pos, type);
    m->symbolTable->AddVariable(taskIndexSym0);
    Symbol *taskIndexSym1 = new Symbol("taskIndex1", pos, type);
    m->symbolTable->AddVariable(taskIndexSym1);
    Symbol *taskIndexSym2 = new Symbol("taskIndex2", pos, type);
    m->symbolTable->AddVariable(taskIndexSym2);

    
    Symbol *taskCountSym0 = new Symbol("taskCount0", pos, type);
    m->symbolTable->AddVariable(taskCountSym0);
    Symbol *taskCountSym1 = new Symbol("taskCount1", pos, type);
    m->symbolTable->AddVariable(taskCountSym1);
    Symbol *taskCountSym2 = new Symbol("taskCount2", pos, type);
    m->symbolTable->AddVariable(taskCountSym2);
}


/** Small utility routine to construct a string for error messages that
    suggests alternate tokens for possibly-misspelled ones... */
static std::string lGetAlternates(std::vector<std::string> &alternates) {
    std::string alts;
    if (alternates.size()) {
        alts += " Did you mean ";
        for (unsigned int i = 0; i < alternates.size(); ++i) {
            alts += std::string("\"") + alternates[i] + std::string("\"");
            if (i < alternates.size() - 1) alts += ", or ";
        }
        alts += "?";
    }
    return alts;
}

static const char *
lGetStorageClassString(StorageClass sc) {
    switch (sc) {
    case SC_NONE:
        return "";
    case SC_EXTERN:
        return "extern";
    case SC_STATIC:
        return "static";
    case SC_TYPEDEF:
        return "typedef";
    case SC_EXTERN_C:
        return "extern \"C\"";
    default:
        Assert(!"logic error in lGetStorageClassString()");
        return "";
    }
}


/** Given an expression, see if it is equal to a compile-time constant
    integer value.  If so, return true and return the value in *value.
    If the expression isn't a compile-time constant or isn't an integer
    type, return false.
*/
static bool
lGetConstantInt(Expr *expr, int *value, SourcePos pos, const char *usage) {
    if (expr == NULL)
        return false;
    expr = TypeCheck(expr);
    if (expr == NULL)
        return false;
    expr = Optimize(expr);
    if (expr == NULL)
        return false;

    std::pair<llvm::Constant *, bool> cValPair = expr->GetConstant(expr->GetType());
    llvm::Constant *cval = cValPair.first;
    if (cval == NULL) {
        Error(pos, "%s must be a compile-time constant.", usage);
        return false;
    }
    else {
        llvm::ConstantInt *ci = llvm::dyn_cast<llvm::ConstantInt>(cval);
        if (ci == NULL) {
            Error(pos, "%s must be a compile-time integer constant.", usage);
            return false;
        }
        if ((int64_t)((int32_t)ci->getSExtValue()) != ci->getSExtValue()) {
            Error(pos, "%s must be representable with a 32-bit integer.", usage);
            return false;
        }
        const Type *type = expr->GetType();
        if (type->IsUnsignedType())
            *value = (int)ci->getZExtValue();
        else
            *value = (int)ci->getSExtValue();
        return true;
    }
}


static EnumType *
lCreateEnumType(const char *name, std::vector<Symbol *> *enums, SourcePos pos) {
    if (enums == NULL)
        return NULL;

    EnumType *enumType = name ? new EnumType(name, pos) : new EnumType(pos);
    if (name != NULL)
        m->symbolTable->AddType(name, enumType, pos);

    lFinalizeEnumeratorSymbols(*enums, enumType);
    for (unsigned int i = 0; i < enums->size(); ++i)
        m->symbolTable->AddVariable((*enums)[i]);
    enumType->SetEnumerators(*enums);
    return enumType;
}


/** Given an array of enumerator symbols, make sure each of them has a
    ConstExpr * in their Symbol::constValue member that stores their
    unsigned integer value.  Symbols that had values explicitly provided
    in the source file will already have ConstExpr * set; we just need
    to set the values for the others here.
*/
static void
lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                           const EnumType *enumType) {
    enumType = enumType->GetAsConstType();
    enumType = enumType->GetAsUniformType();

    /* nextVal tracks the value for the next enumerant.  It starts from
       zero and goes up with each successive enumerant.  If any of them
       has a value specified, then nextVal is ignored for that one and is
       set to one plus that one's value for the default value for the next
       one. */
    uint32_t nextVal = 0;

    for (unsigned int i = 0; i < enums.size(); ++i) {
        enums[i]->type = enumType;
        if (enums[i]->constValue != NULL) {
            /* Already has a value, so first update nextVal with it. */
            int count = enums[i]->constValue->GetValues(&nextVal);
            AssertPos(enums[i]->pos, count == 1);
            ++nextVal;

            /* When the source file as being parsed, the ConstExpr for any
               enumerant with a specified value was set to have unsigned
               int32 type, since we haven't created the parent EnumType
               by then.  Therefore, add a little type cast from uint32 to
               the actual enum type here and optimize it, which will have
               us end up with a ConstExpr with the desired EnumType... */
            Expr *castExpr = new TypeCastExpr(enumType, enums[i]->constValue,
                                              enums[i]->pos);
            castExpr = Optimize(castExpr);
            enums[i]->constValue = llvm::dyn_cast<ConstExpr>(castExpr);
            AssertPos(enums[i]->pos, enums[i]->constValue != NULL);
        }
        else {
            enums[i]->constValue = new ConstExpr(enumType, nextVal++,
                                                 enums[i]->pos);
        }
    }
}
